<?php
/*
  Plugin Name: Adamas Custom Widgets
  Plugin URI: https://slimtemplate.net/
  Description: Adamas Theme Custom Widgets
  Version: 1.1.2
  Author: SlimTemplate
  Text Domain: adamas-custom-widgets
  Domain Path: /lang/
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Adamas_Custom_Widgets' ) ) {

	class Adamas_Custom_Widgets {

		public function __construct() {

			// Translations
			add_action( 'init', array( $this, 'plugin_load_textdomain' ), 9 );

			require plugin_dir_path( __FILE__ ) . '/widgets/widget-brochure.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-shop-info.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-tweets.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-instagram.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-services-menu.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-menu-about.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-testimonials.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-contact.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-recent-posts.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-calendar.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-banner.php';
			require plugin_dir_path( __FILE__ ) . '/widgets/widget-projects.php';

			if ( class_exists( 'woocommerce' ) ) {
				require plugin_dir_path( __FILE__ ) . 'widgets/widget-rating-filter.php';
				require plugin_dir_path( __FILE__ ) . 'widgets/widget-recent-reviews.php';
				require plugin_dir_path( __FILE__ ) . 'widgets/widget-layered-nav.php';
				require plugin_dir_path( __FILE__ ) . 'widgets/widget-layered-nav-filters.php';
			}

		}

		public function plugin_load_textdomain() {
			load_plugin_textdomain( 'adamas-custom-widgets', false, basename( __DIR__ ) . '/lang/' );
		}

	}

}

$AdamasCustomWidgets = new Adamas_Custom_Widgets();