<?php
/*
* Add-on Name: Partner's Block Module
*/
if ( ! class_exists( 'St_Partners_Block_Module' ) ) {
	class St_Partners_Block_Module {
		function __construct() {
			add_shortcode( 'st_partners_block_module', array( $this, 'partners_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'partners_block_module_init' ) );
		}

		function partners_block_module_shortcode( $atts, $content ) {
			$output                   = $partners_block_logo = $partners_block_name = $partners_block_spec = $partners_block_location = $partners_block_link = $partners_block_name_font = $partners_block_name_font_style = $partners_block_name_color = $partners_block_name_font_size = $partners_block_name_line_height = $partners_block_name_letter_spacing = '';
			$partners_block_spec_font = $partners_block_spec_font_style = $partners_block_spec_color = $partners_block_spec_font_size = $partners_block_spec_line_height = $partners_block_spec_letter_spacing = $partners_block_location_font = $partners_block_location_font_style = $partners_block_location_color = $partners_block_location_font_size = $partners_block_location_line_height = $partners_block_location_letter_spacing = '';
			$partners_block_desc_font = $partners_block_desc_font_style = $partners_block_desc_color = $partners_block_desc_font_size = $partners_block_desc_line_height = $partners_block_desc_letter_spacing = $partners_block_disable_border = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'partners_block_logo'                    => '',
				'partners_block_name'                    => '',
				'partners_block_spec'                    => '',
				'partners_block_location'                => '',
				'partners_block_link'                    => '',
				'partners_block_name_font'               => '',
				'partners_block_name_font_style'         => '',
				'partners_block_name_color'              => '',
				'partners_block_name_font_size'          => '',
				'partners_block_name_line_height'        => '',
				'partners_block_name_letter_spacing'     => '',
				'partners_block_spec_font'               => '',
				'partners_block_spec_font_style'         => '',
				'partners_block_spec_color'              => '',
				'partners_block_spec_font_size'          => '',
				'partners_block_spec_line_height'        => '',
				'partners_block_spec_letter_spacing'     => '',
				'partners_block_location_font'           => '',
				'partners_block_location_font_style'     => '',
				'partners_block_location_color'          => '',
				'partners_block_location_font_size'      => '',
				'partners_block_location_line_height'    => '',
				'partners_block_location_letter_spacing' => '',
				'partners_block_desc_font'               => '',
				'partners_block_desc_font_style'         => '',
				'partners_block_desc_color'              => '',
				'partners_block_desc_font_size'          => '',
				'partners_block_desc_line_height'        => '',
				'partners_block_desc_letter_spacing'     => '',
				'partners_block_disable_border'          => '',
				'module_animation'                       => '',
				'el_class'                               => '',
			), $atts ) );


			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$id = uniqid( 'st-partners-block-' );

			if ( $partners_block_disable_border ) {
				$el_class .= ' disable-border';
			}

			$img     = wp_get_attachment_image_src( $atts['partners_block_logo'], 'full' );
			$img_alt = strip_tags( get_post_meta( $atts['partners_block_logo'], '_wp_attachment_image_alt', true ) );
			if ( $img_alt ) {
				$alt = $img_alt;
			} else {
				$alt = $partners_block_name;
			}
			$img_link = esc_url( $img[0] );

			$partners_block_href = vc_build_link( $partners_block_link );
			if ( $partners_block_href !== '' ) {
				$partners_block_target = ( $partners_block_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $partners_block_href['target'] ) ) . '"' : '';
				$partners_block_title  = ( $partners_block_href['title'] !== '' ) ? 'title="' . esc_attr( $partners_block_href['title'] ) . '"' : '';
				if ( ! empty( $partners_block_href['rel'] ) ) {
					$rel = ' rel="' . esc_attr( $partners_block_href['rel'] ) . '"';
				} else {
					$rel = '';
				}
			}

			// Partner's block name
			$partners_block_name_style = 'style="';

			if ( $partners_block_name_font !== '' ) {
				$partners_block_name_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $partners_block_name_font ) : '';
				$partners_block_name_style       .= ! empty( $partners_block_name_font_family ) ? 'font-family:\'' . $partners_block_name_font_family . '\';' : '';
			}

			if ( is_numeric( $partners_block_name_font_size ) ) {
				$partners_block_name_font_size = 'desktop: ' . $partners_block_name_font_size . 'px;';
			}
			if ( is_numeric( $partners_block_name_line_height ) ) {
				$partners_block_name_line_height = 'desktop: ' . $partners_block_name_line_height . 'px;';
			}

			$partners_block_name_args = array(
				'target'      => '#' . $id . ' .st-partners-block-name',
				'media_sizes' => array(
					'font-size'   => $partners_block_name_font_size,
					'line-height' => $partners_block_name_line_height,
				),
			);

			$partners_block_name_responsive = get_ultimate_vc_responsive_media_css( $partners_block_name_args );
			$partners_block_name_style      .= $partners_block_name_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $partners_block_name_letter_spacing ) . 'px;' : '';
			$partners_block_name_style      .= '"';

			// Partner's block specialization
			$partners_block_spec_style = 'style="';

			if ( $partners_block_spec_font !== '' ) {
				$partners_block_spec_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $partners_block_spec_font ) : '';
				$partners_block_spec_style       .= ! empty( $partners_block_spec_font_family ) ? 'font-family:\'' . $partners_block_spec_font_family . '\';' : '';
			}

			if ( is_numeric( $partners_block_spec_font_size ) ) {
				$partners_block_spec_font_size = 'desktop: ' . $partners_block_spec_font_size . 'px;';
			}
			if ( is_numeric( $partners_block_spec_line_height ) ) {
				$partners_block_spec_line_height = 'desktop: ' . $partners_block_spec_line_height . 'px;';
			}

			$partners_block_spec_args = array(
				'target'      => '#' . $id . ' .st-partners-block-spec',
				'media_sizes' => array(
					'font-size'   => $partners_block_spec_font_size,
					'line-height' => $partners_block_spec_line_height,
				),
			);

			$partners_block_spec_responsive = get_ultimate_vc_responsive_media_css( $partners_block_spec_args );
			$partners_block_spec_style      .= $partners_block_spec_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $partners_block_spec_letter_spacing ) . 'px;' : '';
			$partners_block_spec_style      .= '"';

			// Partner's block location
			$partners_block_location_style = 'style="';

			if ( $partners_block_location_font !== '' ) {
				$partners_block_location_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $partners_block_location_font ) : '';
				$partners_block_location_style       .= ! empty( $partners_block_location_font_family ) ? 'font-family:\'' . $partners_block_location_font_family . '\';' : '';
			}

			if ( is_numeric( $partners_block_location_font_size ) ) {
				$partners_block_location_font_size = 'desktop: ' . $partners_block_location_font_size . 'px;';
			}
			if ( is_numeric( $partners_block_location_line_height ) ) {
				$partners_block_location_line_height = 'desktop: ' . $partners_block_location_line_height . 'px;';
			}

			$partners_block_location_args = array(
				'target'      => '#' . $id . ' .st-partners-block-location',
				'media_sizes' => array(
					'font-size'   => $partners_block_location_font_size,
					'line-height' => $partners_block_location_line_height,
				),
			);

			$partners_block_location_responsive = get_ultimate_vc_responsive_media_css( $partners_block_location_args );
			$partners_block_location_style      .= $partners_block_location_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $partners_block_location_letter_spacing ) . 'px;' : '';
			$partners_block_location_style      .= '"';

			// Partner's block description
			$partners_block_desc_style = 'style="';

			if ( $partners_block_desc_font !== '' ) {
				$partners_block_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $partners_block_desc_font ) : '';
				$partners_block_desc_style       .= ! empty( $partners_block_desc_font_family ) ? 'font-family:\'' . $partners_block_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $partners_block_desc_font_size ) ) {
				$partners_block_desc_font_size = 'desktop: ' . $partners_block_desc_font_size . 'px;';
			}
			if ( is_numeric( $partners_block_desc_line_height ) ) {
				$partners_block_desc_line_height = 'desktop: ' . $partners_block_desc_line_height . 'px;';
			}

			$partners_block_desc_args = array(
				'target'      => '#' . $id . ' .st-partners-block-desc',
				'media_sizes' => array(
					'font-size'   => $partners_block_desc_font_size,
					'line-height' => $partners_block_desc_line_height,
				),
			);

			$partners_block_desc_responsive = get_ultimate_vc_responsive_media_css( $partners_block_desc_args );
			$partners_block_desc_style      .= $partners_block_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $partners_block_desc_letter_spacing ) . 'px;' : '';
			$partners_block_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-partners-block ' . esc_attr( $el_class ) . '" id="' . esc_attr( $id ) . '">';
			if ( $partners_block_link !== '' ) {
				$output .= '<a href="' . esc_url( $partners_block_href['url'] ) . '" ' . $partners_block_title . ' ' . $partners_block_target . ' ' . $rel . '>';
			}
			$output .= '<div class="st-partners-block-logo"><img src="' . esc_url( $img_link ) . '" alt="' . esc_attr( $alt ) . '" /></div>';
			if ( $partners_block_link !== '' ) {
				$output .= '</a>';
			}
			$output .= '<div class="st-partners-block-inner">';
			$output .= '<div class="st-partners-block-name ult-responsive" ' . $partners_block_name_style . ' ' . $partners_block_name_responsive . '>';
			if ( $partners_block_link !== '' ) {
				$output .= '<a href="' . esc_url( $partners_block_href['url'] ) . '" ' . esc_attr( $partners_block_title ) . ' ' . esc_attr( $partners_block_target ) . '>';
			}
			$output .= $partners_block_name;
			if ( $partners_block_link !== '' ) {
				$output .= '</a>';
			}
			$output .= '</div>';
			$output .= '<div class="st-partners-block-spec ult-responsive" ' . $partners_block_spec_style . ' ' . $partners_block_spec_responsive . '>' . esc_attr( $partners_block_spec ) . '</div>';
			$output .= '<div class="st-partners-block-location ult-responsive" ' . $partners_block_location_style . ' ' . $partners_block_location_responsive . '>' . esc_attr( $partners_block_location ) . '</div>';
			$output .= '<div class="st-partners-block-desc ult-responsive" ' . $partners_block_desc_style . ' ' . $partners_block_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
			$output .= '</div>'; // st-partners-block-inner
			$output .= '</div>'; // st-partners-block

			return $output;
		}

		function partners_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Partner Block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_partners_block_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/partner_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays partners detailed info', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Logo', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_logo',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name',
							'description' => '',
							'admin_label' => true
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Specialization', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Location', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location',
							'description' => '',
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_link',
							'description' => ''
						),
						array(
							'type'        => 'checkbox',
							'heading'     => __( 'Disable bottom border', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_disable_border',
							'value'       => array( __( 'Yes', 'adamas-vc-shortcodes' ) => 'yes' ),
							'description' => ''
						),

						// Partner's name typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Name font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Name font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Name font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Name letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_name_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Partner's specialization typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Specialization font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Specialization font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Specialization font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Specialization font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Specialization line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Specialization letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_spec_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Partner's location typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Location font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Location font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Location font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Location font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Location line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Location letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_location_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Partner's description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'partners_block_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_partners_block_module = new St_Partners_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_partners_block_module extends WPBakeryShortCode {
		}
	}
}