<?php
/*
 * Add-on Name: Vertical Carousel Module
 */
if ( ! class_exists( 'St_Vertical_Carousel_Module' ) ) {
	class St_Vertical_Carousel_Module {
		function __construct() {
			add_shortcode( 'st_vertical_carousel_module', array( $this, 'vertical_carousel_module_shortcode' ) );
			add_action( 'init', array( $this, 'vertical_carousel_module_init' ) );
		}

		function vertical_carousel_module_shortcode( $atts ) {
			$carousel_data     = '';
			$carousel_img      = $carousel_title = $carousel_title_font = $carousel_title_font_style = $carousel_title_color = $carousel_title_font_size = $carousel_title_line_height = $carousel_title_letter_spacing = '';
			$carousel_subtitle = $carousel_subtitle_font = $carousel_subtitle_font_style = $carousel_subtitle_color = $carousel_subtitle_font_size = $carousel_subtitle_line_height = $carousel_subtitle_letter_spacing = '';
			$carousel_desc     = $carousel_desc_font = $carousel_desc_font_style = $carousel_desc_color = $carousel_desc_font_size = $carousel_desc_line_height = $carousel_desc_letter_spacing = '';
			$el_class          = $module_animation = $animation = $animated = '';

			extract( shortcode_atts( array(
				'carousel_data'                    => '',
				'carousel_img'                     => '',
				'carousel_title'                   => '',
				'carousel_title_font'              => '',
				'carousel_title_font_style'        => '',
				'carousel_title_color'             => '',
				'carousel_title_font_size'         => '',
				'carousel_title_line_height'       => '',
				'carousel_title_letter_spacing'    => '',
				'carousel_subtitle'                => '',
				'carousel_subtitle_font'           => '',
				'carousel_subtitle_font_style'     => '',
				'carousel_subtitle_color'          => '',
				'carousel_subtitle_font_size'      => '',
				'carousel_subtitle_line_height'    => '',
				'carousel_subtitle_letter_spacing' => '',
				'carousel_desc'                    => '',
				'carousel_desc_font'               => '',
				'carousel_desc_font_style'         => '',
				'carousel_desc_color'              => '',
				'carousel_desc_font_size'          => '',
				'carousel_desc_line_height'        => '',
				'carousel_desc_letter_spacing'     => '',
				'module_animation'                 => '',
				'el_class'                         => '',
			), $atts ) );

			$carousel_count = 0;
			$output         = '';

			$carousel_data = json_decode( urldecode( $carousel_data ), true );

			$id = uniqid( 'st-vertical-carousel-' );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"'; // TODO : Check animation
			}

			// Title
			$carousel_title_style = 'style="';

			if ( $carousel_title_font !== '' ) {
				$carousel_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $carousel_title_font ) : '';
				$carousel_title_style       .= ! empty( $carousel_title_font_family ) ? 'font-family:\'' . $carousel_title_font_family . '\';' : '';
			}
			if ( $carousel_title_font_style !== '' ) {
				$carousel_title_style .= esc_attr( $carousel_title_font_style );
			}

			if ( is_numeric( $carousel_title_font_size ) ) {
				$carousel_title_font_size = 'desktop: ' . $carousel_title_font_size . 'px;';
			}
			if ( is_numeric( $carousel_title_line_height ) ) {
				$carousel_title_line_height = 'desktop: ' . $carousel_title_line_height . 'px;';
			}

			$carousel_title_args = array(
				'target'      => '#' . $id . ' .st-vertical-carousel-title',
				'media_sizes' => array(
					'font-size'   => $carousel_title_font_size,
					'line-height' => $carousel_title_line_height,
				),
			);

			$carousel_title_responsive = get_ultimate_vc_responsive_media_css( $carousel_title_args );
			$carousel_title_style      .= $carousel_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $carousel_title_letter_spacing ) . 'px;' : '';
			$carousel_title_style      .= $carousel_title_color !== '' ? 'color:' . esc_attr( $carousel_title_color ) . ';' : '';
			$carousel_title_style      .= '"';

			// Subtitle
			$carousel_subtitle_style = 'style="';

			if ( $carousel_subtitle_font !== '' ) {
				$carousel_subtitle_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $carousel_subtitle_font ) : '';
				$carousel_subtitle_style       .= ! empty( $carousel_subtitle_font_family ) ? 'font-family:\'' . $carousel_subtitle_font_family . '\';' : '';
			}
			if ( $carousel_subtitle_font_style !== '' ) {
				$carousel_subtitle_style .= esc_attr( $carousel_subtitle_font_style );
			}

			if ( is_numeric( $carousel_subtitle_font_size ) ) {
				$carousel_subtitle_font_size = 'desktop: ' . $carousel_subtitle_font_size . 'px;';
			}
			if ( is_numeric( $carousel_subtitle_line_height ) ) {
				$carousel_subtitle_line_height = 'desktop: ' . $carousel_subtitle_line_height . 'px;';
			}

			$carousel_subtitle_args = array(
				'target'      => '#' . $id . ' .st-vertical-carousel-subtitle',
				'media_sizes' => array(
					'font-size'   => $carousel_subtitle_font_size,
					'line-height' => $carousel_subtitle_line_height,
				),
			);

			$carousel_subtitle_responsive = get_ultimate_vc_responsive_media_css( $carousel_subtitle_args );
			$carousel_subtitle_style      .= $carousel_subtitle_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $carousel_subtitle_letter_spacing ) . 'px;' : '';
			$carousel_subtitle_style      .= $carousel_subtitle_color !== '' ? 'color:' . esc_attr( $carousel_subtitle_color ) . ';' : '';
			$carousel_subtitle_style      .= '"';

			// Description
			$carousel_desc_style = 'style="';

			if ( $carousel_desc_font !== '' ) {
				$carousel_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $carousel_desc_font ) : '';
				$carousel_desc_style       .= ! empty( $carousel_desc_font_family ) ? 'font-family:\'' . $carousel_desc_font_family . '\';' : '';
			}
			if ( $carousel_desc_font_style !== '' ) {
				$carousel_desc_style .= esc_attr( $carousel_desc_font_style );
			}

			if ( is_numeric( $carousel_desc_font_size ) ) {
				$carousel_desc_font_size = 'desktop: ' . $carousel_desc_font_size . 'px;';
			}
			if ( is_numeric( $carousel_desc_line_height ) ) {
				$carousel_desc_line_height = 'desktop: ' . $carousel_desc_line_height . 'px;';
			}

			$carousel_desc_args = array(
				'target'      => '#' . $id . ' .st-vertical-carousel-desc',
				'media_sizes' => array(
					'font-size'   => $carousel_desc_font_size,
					'line-height' => $carousel_desc_line_height,
				),
			);

			$carousel_desc_responsive = get_ultimate_vc_responsive_media_css( $carousel_desc_args );
			$carousel_desc_style      .= $carousel_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $carousel_desc_letter_spacing ) . 'px;' : '';
			$carousel_desc_style      .= $carousel_desc_color !== '' ? 'color:' . esc_attr( $carousel_desc_color ) . ';' : '';
			$carousel_desc_style      .= '"';

			if ( is_rtl() ) {
				$rtl = 'rtl';
			} else {
				$rtl = '';
			}

			$output .= '<div class="st-vertical-carousel"><div id="' . esc_attr( $id ) . '" class="st-vertical-carousel-slider ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
			if ( isset( $carousel_data ) ) {
				foreach ( $carousel_data as $carousel_datas ) {
					$output .= '<div class="st-vertical-carousel-item">';
					if ( isset( $carousel_datas['carousel_img'] ) ) {
						$images_arr = explode( ',', $carousel_datas['carousel_img'] );
						if ( count( $images_arr ) === 1 ) {
							$img        = wp_get_attachment_image_src( $images_arr[0], 'full' );
							$img_link   = $img[0];
							$background = ' style="background-image: url(' . esc_url( $img_link ) . ')"';
							$images     = '<div class="st-vertical-carousel-img" ' . $background . '></div>';
						} else {
							$images = '<div class="st-vertical-carousel-img st-vertical-carousel-inner-gallery ' . $rtl . '">';
							foreach ( $images_arr as $image_id ) {
								$img        = wp_get_attachment_image_src( $image_id, 'full' );
								$img_link   = $img[0];
								$background = ' style="background-image: url(' . esc_url( $img_link ) . ')"';
								$images     .= '<div class="st-vertical-carousel-inner-img" ' . $background . '></div>';
							}
							$images .= '</div>';
						}
					}
					$output .= $images;
					$output .= '<div class="st-vertical-carousel-info">';
					$output .= '<div class="st-vertical-carousel-title-wrapper">';
					$output .= '<div class="st-vertical-carousel-title-sep"></div>';
					if ( isset( $carousel_datas['carousel_title'] ) ) {
						$output .= '<div class="st-vertical-carousel-title ult-responsive" ' . $carousel_title_style . ' ' . $carousel_title_responsive . '><h3>' . esc_attr( $carousel_datas['carousel_title'] ) . '</h3></div>';
					}
					if ( isset( $carousel_datas['carousel_subtitle'] ) ) {
						$output .= '<div class="st-vertical-carousel-subtitle ult-responsive" ' . $carousel_subtitle_style . ' ' . $carousel_subtitle_responsive . '>' . esc_attr( $carousel_datas['carousel_subtitle'] ) . '</div>';
					}
					$output .= '</div>'; // st-vertical-carousel-title-wrapper
					if ( isset( $carousel_datas['carousel_desc'] ) ) {
						$output .= '<div class="st-vertical-carousel-desc ult-responsive" ' . $carousel_desc_style . ' ' . $carousel_desc_responsive . '>' . wp_kses_post( $carousel_datas['carousel_desc'] ) . '</div>';
					}
					if ( isset( $carousel_datas['carousel_link'] ) ) {
						$link   = vc_build_link( $carousel_datas['carousel_link'] );
						$output .= '<a class="st-vertical-carousel-link" href="' . esc_url( $link['url'] ) . '" ' . ( $link['target'] ? ' target="' . esc_attr( trim( $link['target'] ) ) . '"' : '' ) . ' title="' . esc_attr( $link['title'] ) . '" ' . ( $link['rel'] ? ' rel="' . esc_attr( $link['rel'] ) . '"' : '' ) . '>' . esc_attr( $link['title'] ) . '</a>';
					}
					$output .= '</div>'; // st-vertical-carousel-info
					$output .= '</div>'; // st-vertical-carousel-item
				}
			}
			$output .= '</div>'; // st-vertical-carousel-slider
			$output .= '</div>'; // st-vertical-carousel

			wp_enqueue_script( 'slick' );

			return $output;
		}

		function vertical_carousel_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Vertical Carousel', 'adamas-vc-shortcodes' ),
					'base'        => 'st_vertical_carousel_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/vertical_carousel.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays in vertical carousel', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'       => 'param_group',
							'heading'    => __( 'Carousel settings', 'adamas-vc-shortcodes' ),
							'param_name' => 'carousel_data',
							'value'      => urlencode( json_encode( array(
								array(
									'carousel_title'    => '',
									'carousel_subtitle' => '',
									'carousel_img'      => '',
									'carousel_desc'     => '',
									'carousel_link'     => '',
								)
							) ) ),
							'params'     => array(
								array(
									'type'       => 'attach_images',
									'heading'    => __( 'Images', 'adamas-vc-shortcodes' ),
									'param_name' => 'carousel_img',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
									'param_name'  => 'carousel_title',
									'description' => '',
									'admin_label' => true
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Subtitle', 'adamas-vc-shortcodes' ),
									'param_name'  => 'carousel_subtitle',
									'description' => '',
								),
								array(
									'type'        => 'textarea',
									'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
									'param_name'  => 'carousel_desc',
									'value'       => '',
									'description' => '',
								),
								array(
									'type'        => 'vc_link',
									'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
									'param_name'  => 'carousel_link',
									'description' => __( 'Add a custom link or select existing page. You can remove existing link as well.', 'adamas-vc-shortcodes' )
								),
							),
						),
						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Subtitle font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Subtitle font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Subtitle font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Subtitle letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_subtitle_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'carousel_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_vertical_carousel_module = new St_Vertical_Carousel_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_vertical_carousel_module extends WPBakeryShortCode {
		}
	}
}