<?php
/*
  Plugin Name: Adamas Demo Import
  Plugin URI: http://slimtemplate.net/
  Description: Adamas Demo Importer
  Version: 1.0
  Author: SlimTemplate
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Adamas_Demo_Import' ) ) {

	class Adamas_Demo_Import {

		public function __construct() {

			add_action( 'admin_menu', array( $this, 'add_import_page' ) );
			add_action( 'wp_ajax_st_adamas_import_content', array( $this, 'import_content' ) );

		}

		public function add_import_page() {
			add_management_page(
				'Demo Import',
				'Demo Import',
				'manage_options',
				'st_adamas_import',
				array( $this, 'import' )
			);
		}

		public function import() {
			?>
            <div class="wrap">
                <div class="demoimport content" style="display:none;">
                    <h1>Importing Demo Content...</h1>
                    <p>Please be patient and <strong>do not navigate away</strong> from this page while the import is in
                        progress. This may take up to several minutes (according to your server speed). You will get a
                        notification on this page when the import is completed.</p>
                </div>
                <div class="demoimport success" style="display:none;">
                    <h1>Import completed successfully!</h1>
                    <p>The Demo Import was successfully.<br>
                        <a href="<?php echo site_url(); ?>" target="_blank">View your page</a>.<br>
                        Also, you can start to customize website with <a href="<?php echo admin_url( 'admin.php?page=_options' ); ?>">Theme Options</a>.
                </div>
                <div class="demoimport failure" style="display:none;">
                    <h1>Error!</h1>
                    <p class="failure"></p>
                </div>
                <form class="import-form" action="?page=st_adamas_import" method="post">
                    <div class="demoimport-importer-options">
                        <h2>Demo Importer</h2>
                        <p>Welcome to Demo Importer!<br>
                            <strong>Notice:</strong> Standard content gets always imported (including pages, images,
                            navigation).<br>
                            <strong>If you want to import the demo content for plugins (ContactForm 7, MailChimp for
                                WordPress, Revolution Slider), make sure to install them before running demo
                                import!</strong></p>
                        <br>
                        <div class="important-notes">
							<?php if ( ! class_exists( 'RevSlider' ) ) {
								echo '<div class="demoimport-importer-note demoimport-importer-error"><strong style="color:red">Warning!</strong> <strong>Revolution Slider</strong> plugin is not active. Please activate it if you want sliders to be imported.</div>';
							} ?>
							<?php if ( ! class_exists( 'WPCF7' ) ) {
								echo '<div class="demoimport-importer-note demoimport-importer-error"><strong style="color:red">Warning!</strong> <strong>Contact Form 7</strong> plugin is not active. Please activate it if you want contact forms to be imported.</div>';
							} ?>
							<?php if ( ! class_exists( 'MC4WP_Form_Manager' ) ) {
								echo '<div class="demoimport-importer-note demoimport-importer-error"><strong style="color:red">Warning!</strong> <strong>MailChimp for WordPress</strong> plugin is not active. Please activate it if you want MailChimp form to be imported.</div>';
							} ?>
                            <br>
                            <strong>Important Notes:</strong>
                            <ol>
                                <li>We recommend to run the Demo Import on a clean WordPress installation.</li>
                                <li>To reset your installation (if the import fails) we recommend <a
                                            href="https://wordpress.org/plugins/wordpress-reset/" target="_blank">WordPress
                                        Reset Plugin</a>.
                                </li>
                                <li>Demo Import will not import the images we have used in our live demo, due to copyright /
                                    license reasons.
                                </li>
                                <li>Do not run the Demo Import multiple times, it will result in duplicated content (see
                                    step 2).
                                </li>
                            </ol>
                        </div>
                        <br>
                        <div class="demo-images">
                            <label for="usa-demo" class="demoimport-usa-demo-check">
                                <input id="usa-demo" type="radio" name="demo_choice" value="usa" checked>
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/usa.png'; ?>"/>
                            </label>
                            <label for="de-demo" class="demoimport-de-demo-check">
                                <input id="de-demo" type="radio" name="demo_choice" value="de">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/de.png'; ?>"/>
                            </label>
                            <label for="au-demo" class="demoimport-au-demo-check">
                                <input id="au-demo" type="radio" name="demo_choice" value="au">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/au.png'; ?>"/>
                            </label>
                            <label for="jp-demo" class="demoimport-jp-demo-check">
                                <input id="jp-demo" type="radio" name="demo_choice" value="jp">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/jp.png'; ?>"/>
                            </label>
                            <label for="uk-demo" class="demoimport-uk-demo-check">
                                <input id="uk-demo" type="radio" name="demo_choice" value="uk">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/uk.png'; ?>"/>
                            </label>
                            <label for="uae-demo" class="demoimport-uae-demo-check">
                                <input id="uae-demo" type="radio" name="demo_choice" value="uae">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/uae.png'; ?>"/>
                            </label>
                            <label for="fr-demo" class="demoimport-fr-demo-check">
                                <input id="fr-demo" type="radio" name="demo_choice" value="fr">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/fr.png'; ?>"/>
                            </label>
                            <label for="it-demo" class="demoimport-it-demo-check">
                                <input id="it-demo" type="radio" name="demo_choice" value="it">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/it.png'; ?>"/>
                            </label>
                            <label for="tr-demo" class="demoimport-tr-demo-check">
                                <input id="tr-demo" type="radio" name="demo_choice" value="tr">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/tr.png'; ?>"/>
                            </label>
                            <label for="cn-demo" class="demoimport-cn-demo-check">
                                <input id="cn-demo" type="radio" name="demo_choice" value="cn">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/cn.png'; ?>"/>
                            </label>
                            <label for="in-demo" class="demoimport-in-demo-check">
                                <input id="in-demo" type="radio" name="demo_choice" value="in">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/in.png'; ?>"/>
                            </label>
                            <label for="ca-demo" class="demoimport-ca-demo-check">
                                <input id="ca-demo" type="radio" name="demo_choice" value="ca">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/ca.png'; ?>"/>
                            </label>
                            <label for="es-demo" class="demoimport-es-demo-check">
                                <input id="es-demo" type="radio" name="demo_choice" value="es">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . '/images/es.png'; ?>"/>
                            </label>
                        </div>
                        <br>
                        <input name="submit" class="button-primary size_big" type="submit" value="Import"
                               id="import_demo_data">
                    </div>
                </form>
            </div>
            <script>
              jQuery(document).ready(function() {
                var st_import = false;
                var selected = jQuery('.import-form').val();
                jQuery('input[name=demo_choice]').on('change', function() {
                  selected = jQuery(this).val();
                });

                jQuery('#import_demo_data').click(function() {
                  if (!st_import) {
                    st_import = true;
                    jQuery('html, body').animate({scrollTop: 0}, {duration: 300});
                    jQuery('.import-form').fadeOut(null, function() {
                      jQuery('.demoimport.content').fadeIn();
                    });

                    // Importing Content
                    jQuery.ajax({
                      type: 'POST',
                      url: '<?php echo admin_url( 'admin-ajax.php' ); ?>',
                      data: {
                        'selected_demo': selected,
                        action: 'st_adamas_import_content',
                      },
                      success: function(data, textStatus, XMLHttpRequest) {
                        jQuery('.demoimport.content').fadeOut();
                        jQuery('.demoimport.success').fadeIn();
                        st_import = false;
                      },
                      error: function(XMLHttpRequest, textStatus, errorThrown) {
                        jQuery('.demoimport.content').fadeOut();
                        jQuery('.demoimport.failure').fadeIn();
                        jQuery('p.failure').append('Status: ' + textStatus, '<br>Error: ' + errorThrown);
                        st_import = false;
                      },
                    });
                  }
                  return false;
                });
              });
            </script>
			<?php
		}

		// Content
		public function import_content() {

			if ( ! empty( $_POST['selected_demo'] ) ) {
				$selected_demo = $_POST['selected_demo'];
			} else {
				$selected_demo = 'usa';
			}

			ini_set( 'max_execution_time', '300' );
			ini_set( 'memory_limit', '512M' );

			if ( ! defined( 'WP_LOAD_IMPORTERS' ) ) {
				define( 'WP_LOAD_IMPORTERS', true );
			}

			require plugin_dir_path( __FILE__ ) . 'wordpress-importer/plugin.php';

			$importer = new WXR_Importer( array(
				'fetch_attachments' => true,
				'default_author'    => get_current_user_id(),
			) );
			$logger   = new WP_Importer_Logger_ServerSentEvents();
			$importer->set_logger( $logger );

			$content_file = download_url( 'https://slimtemplate.net/adamas/import/content/' . $selected_demo . '.xml' );

			$importer->import( $content_file );

			@unlink( $content_file );

			WP_Filesystem();
			global $wp_filesystem;

			// Widgets
			$widget_file = download_url( 'https://slimtemplate.net/adamas/import/content/widgets_' . $selected_demo . '.json' );
			$data        = $wp_filesystem->get_contents( $widget_file );
			$data        = json_decode( $data );

			$this->import_widgets( $data );

			@unlink( $widget_file );

			// Theme options
			$theme_options_file = download_url( 'https://slimtemplate.net/adamas/import/theme_options/theme_options_' . $selected_demo . '.json' );

			$file_contents = $wp_filesystem->get_contents( $theme_options_file );
			$options       = json_decode( $file_contents, true );
			$redux         = ReduxFrameworkInstances::get_instance( 'adamas' );
			$redux->set_options( $options );

			unset( $redux );
			@unlink( $theme_options_file );

			// Refresh Theme options
			st_adamas_saving_theme_options();

			// Set Menu
			$locations = get_theme_mod( 'nav_menu_locations' );
			$menus     = wp_get_nav_menus();

			if ( ! empty( $menus ) ) {
				foreach ( $menus as $menu ) {
					if ( is_object( $menu ) && $menu->name === 'Main Menu' ) {
						$locations['primary_navigation'] = $menu->term_id;
					}
				}
			}
			set_theme_mod( 'nav_menu_locations', $locations );

			// Front Page ID
			if ( $selected_demo === 'usa' ) {
				$front_page = 2865;
			} elseif ( $selected_demo === 'de' ) {
				$front_page = 6549;
			} elseif ( $selected_demo === 'au' ) {
				$front_page = 6666;
			} elseif ( $selected_demo === 'jp' ) {
				$front_page = 7017;
			} elseif ( $selected_demo === 'uk' ) {
				$front_page = 7787;
			} elseif ( $selected_demo === 'uae' ) {
				$front_page = 8015;
			} elseif ( $selected_demo === 'fr' ) {
				$front_page = 10839;
			} elseif ( $selected_demo === 'it' ) {
				$front_page = 11350;
			} elseif ( $selected_demo === 'tr' ) {
				$front_page = 11131;
			} elseif ( $selected_demo === 'cn' ) {
				$front_page = 11740;
			} elseif ( $selected_demo === 'in' ) {
				$front_page = 12446;
			} elseif ( $selected_demo === 'ca' ) {
				$front_page = 13287;
			} elseif ( $selected_demo === 'es' ) {
				$front_page = 14238;
			}
			// Posts page ID
			$page_for_posts = 1179;

			// Set Front and Posts pages
			if ( isset( $front_page ) ) {
				update_option( 'show_on_front', 'page' );
				update_option( 'page_on_front', $front_page );
				update_option( 'page_for_posts', $page_for_posts );
			}

			// RevSliders
			if ( ! class_exists( 'RevSlider' ) ) {
				return false;
			}

			ob_start();

			if ( $selected_demo === 'usa' ) {
				$slider1                           = download_url( 'https://slimtemplate.net/adamas/import/revsliders/usa.zip' );
				$_FILES["import_file"]["tmp_name"] = $slider1;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $slider1 );
			}

			$slider2                           = download_url( 'https://slimtemplate.net/adamas/import/revsliders/logistics-' . $selected_demo . '.zip' );
			$_FILES["import_file"]["tmp_name"] = $slider2;
			$slider                            = new RevSlider();
			$response                          = $slider->importSliderFromPost();
			unset( $slider );
			@unlink( $slider2 );

			$OurCompanySlider                  = download_url( 'https://slimtemplate.net/adamas/import/revsliders/about-' . $selected_demo . '.zip' );
			$_FILES["import_file"]["tmp_name"] = $OurCompanySlider;
			$slider                            = new RevSlider();
			$response                          = $slider->importSliderFromPost();
			unset( $slider );
			@unlink( $OurCompanySlider );

			$finance_slider                    = download_url( 'https://slimtemplate.net/adamas/import/revsliders/finance-' . $selected_demo . '.zip' );
			$_FILES["import_file"]["tmp_name"] = $finance_slider;
			$slider                            = new RevSlider();
			$response                          = $slider->importSliderFromPost();
			unset( $slider );
			@unlink( $finance_slider );

			$commerceSlider                    = download_url( 'https://slimtemplate.net/adamas/import/revsliders/commerce-' . $selected_demo . '.zip' );
			$_FILES["import_file"]["tmp_name"] = $commerceSlider;
			$slider                            = new RevSlider();
			$response                          = $slider->importSliderFromPost();
			unset( $slider );
			@unlink( $commerceSlider );

			$projects                          = download_url( 'https://slimtemplate.net/adamas/import/revsliders/projects-' . $selected_demo . '.zip' );
			$_FILES["import_file"]["tmp_name"] = $projects;
			$slider                            = new RevSlider();
			$response                          = $slider->importSliderFromPost();
			unset( $slider );
			@unlink( $projects );

			if ( $selected_demo === 'de' ) {
				$mainslider2                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/de.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider2;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider2 );
			}

			if ( $selected_demo === 'au' ) {
				$mainslider3                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/au.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider3;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider3 );
			}

			if ( $selected_demo === 'jp' ) {
				$mainslider4                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/jp.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider4;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider4 );
			}

			if ( $selected_demo === 'uae' ) {
				$mainslider5                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/uae.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider5;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider5 );
			}

			if ( $selected_demo === 'fr' ) {
				$mainslider6                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/fr.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider6;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider6 );
			}

			if ( $selected_demo === 'it' ) {
				$mainslider8                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/it.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider8;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider8 );
			}

			if ( $selected_demo === 'tr' ) {
				$mainslider9                       = download_url( 'https://slimtemplate.net/adamas/import/revsliders/tr.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider9;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider9 );
			}

			if ( $selected_demo === 'cn' ) {
				$mainslider10                      = download_url( 'https://slimtemplate.net/adamas/import/revsliders/cn.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider10;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider10 );
			}

			if ( $selected_demo === 'in' ) {
				$mainslider11                      = download_url( 'https://slimtemplate.net/adamas/import/revsliders/in.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider11;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider11 );
			}

			if ( $selected_demo === 'ca' ) {
				$mainslider12                      = download_url( 'https://slimtemplate.net/adamas/import/revsliders/ca.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider12;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider12 );
			}

			if ( $selected_demo === 'es' ) {
				$mainslider13                      = download_url( 'https://slimtemplate.net/adamas/import/revsliders/es.zip' );
				$_FILES["import_file"]["tmp_name"] = $mainslider13;
				$slider                            = new RevSlider();
				$response                          = $slider->importSliderFromPost();
				unset( $slider );
				@unlink( $mainslider13 );
			}

			ob_end_clean();
			die();

		}

		public function available_widgets() {
			global $wp_registered_widget_controls;
			$widget_controls   = $wp_registered_widget_controls;
			$available_widgets = array();
			foreach ( $widget_controls as $widget ) {
				if ( ! empty( $widget['id_base'] ) && ! isset( $available_widgets[ $widget['id_base'] ] ) ) { // no dupes
					$available_widgets[ $widget['id_base'] ]['id_base'] = $widget['id_base'];
					$available_widgets[ $widget['id_base'] ]['name']    = $widget['name'];
				}
			}

			return $available_widgets;
		}

		public function import_widgets( $data ) {
			global $wp_registered_sidebars;

			// Get all available widgets site supports
			$available_widgets = $this->available_widgets();

			// Get all existing widget instances
			$widget_instances = array();
			foreach ( $available_widgets as $widget_data ) {
				$widget_instances[ $widget_data['id_base'] ] = get_option( 'widget_' . $widget_data['id_base'] );
			}

			// Loop import data's sidebars
			foreach ( $data as $sidebar_id => $widgets ) {

				// Skip inactive widgets
				// (should not be in export file)
				if ( 'wp_inactive_widgets' === $sidebar_id ) {
					continue;
				}

				// Check if sidebar is available on this site
				// Otherwise add widgets to inactive, and say so
				if ( isset( $wp_registered_sidebars[ $sidebar_id ] ) ) {
					$sidebar_available = true;
					$use_sidebar_id    = $sidebar_id;
				} else {
					$sidebar_available = false;
					$use_sidebar_id    = 'wp_inactive_widgets'; // add to inactive if sidebar does not exist in theme
				}

				// Loop widgets
				foreach ( $widgets as $widget_instance_id => $widget ) {

					$fail = false;

					// Get id_base (remove -# from end) and instance ID number
					$id_base            = preg_replace( '/-[0-9]+$/', '', $widget_instance_id );
					$instance_id_number = str_replace( $id_base . '-', '', $widget_instance_id );

					// Does site support this widget?
					if ( ! $fail && ! isset( $available_widgets[ $id_base ] ) ) {
						$fail = true;
					}

					$widget = json_decode( json_encode( $widget ), true );

					// Does widget with identical settings already exist in same sidebar?
					if ( ! $fail && isset( $widget_instances[ $id_base ] ) ) {

						// Get existing widgets in this sidebar
						$sidebars_widgets = get_option( 'sidebars_widgets' );
						$sidebar_widgets  = isset( $sidebars_widgets[ $use_sidebar_id ] ) ? $sidebars_widgets[ $use_sidebar_id ] : array(); // check Inactive if that's where will go

						// Loop widgets with ID base
						$single_widget_instances = ! empty( $widget_instances[ $id_base ] ) ? $widget_instances[ $id_base ] : array();
						foreach ( $single_widget_instances as $check_id => $check_widget ) {
							// Is widget in same sidebar and has identical settings?
							if ( in_array( "$id_base-$check_id", $sidebar_widgets ) && (array) $widget == $check_widget ) {
								$fail = true;
								break;
							}
						}
					}

					// No failure
					if ( ! $fail ) {

						// Add widget instance
						$single_widget_instances   = get_option( 'widget_' . $id_base ); // all instances for that widget ID base, get fresh every time
						$single_widget_instances   = ! empty( $single_widget_instances ) ? $single_widget_instances : array( '_multiwidget' => 1 ); // start fresh if have to
						$single_widget_instances[] = $widget; // add it

						// Get the key it was given
						end( $single_widget_instances );
						$new_instance_id_number = key( $single_widget_instances );

						// If key is 0, make it 1
						// When 0, an issue can occur where adding a widget causes data from other widget to load, and the widget doesn't stick (reload wipes it)
						if ( '0' === (string) $new_instance_id_number ) {
							$new_instance_id_number                             = 1;
							$single_widget_instances[ $new_instance_id_number ] = $single_widget_instances[0];
							unset( $single_widget_instances[0] );
						}

						// Move _multiwidget to end of array for uniformity
						if ( isset( $single_widget_instances['_multiwidget'] ) ) {
							$multiwidget = $single_widget_instances['_multiwidget'];
							unset( $single_widget_instances['_multiwidget'] );
							$single_widget_instances['_multiwidget'] = $multiwidget;
						}

						// Update option with new widget
						update_option( 'widget_' . $id_base, $single_widget_instances );

						// Assign widget instance to sidebar
						$sidebars_widgets                      = get_option( 'sidebars_widgets' ); // which sidebars have which widgets, get fresh every time
						$new_instance_id                       = $id_base . '-' . $new_instance_id_number; // use ID number from new widget instance
						$sidebars_widgets[ $use_sidebar_id ][] = $new_instance_id; // add new instance to sidebar
						update_option( 'sidebars_widgets', $sidebars_widgets ); // save the amended data

					}
				}
			}
		}

	}

	new Adamas_Demo_Import;

}