<?php
/*
* Add-on Name: Info Box
* Add-on URI: https://www.brainstormforce.com
*/
if ( ! class_exists( 'AIO_Icons_Box' ) ) {
	class AIO_Icons_Box {
		function __construct() {
			if ( Ultimate_VC_Addons::$uavc_editor_enable ) {
				// Initialize the icon box component for WPBakery Page Builder
				add_action( 'init', array( &$this, 'icon_box_init' ) );
			}
			// Add shortcode for icon box
			add_shortcode( 'bsf-info-box', array( &$this, 'icon_boxes' ) );
			add_action( 'wp_enqueue_scripts', array( $this, 'icon_box_scripts' ), 1 );

		}

		// Add shortcode for icon-box
		function icon_boxes( $atts, $content = null ) {
			$icon_type        = $icon_img = $img_width = $icon = $icon_color = $icon_color_bg = $icon_size = $icon_style = $icon_border_style = $icon_border_radius = $icon_color_border = $icon_border_size = $icon_border_spacing = $el_class = $icon_animation = $title = $link = $hover_effect = $pos = $read_more = $read_text = $box_border_style = $box_border_width = $box_border_color = $box_bg_color = $pos = $css_class = $desc_font_line_height = $title_font_line_height = $heading_tag = '';
			$title_font       = $title_font_style = $title_font_size = $title_font_color = $desc_font = $desc_font_style = $desc_font_size = $desc_font_color = $box_min_height = $target = $link_title = $rel = '';
			$icon_color_hover = $icon_color_bg_hover = $icon_color_border_hover = $style = $module_animation = $animation = $animated = $elem = $generic_box_style = $desc_margin_top = '';

			extract( shortcode_atts( array(
				'icon_type'                  => 'selector',
				'icon'                       => 'none',
				'icon_img'                   => '',
				'img_width'                  => '48',
				'icon_size'                  => '32',
				'icon_color'                 => '#333',
				'icon_style'                 => 'none',
				'icon_color_bg'              => '#ffffff',
				'icon_color_border'          => '#333333',
				'icon_border_style'          => '',
				'icon_border_size'           => '1',
				'icon_border_radius'         => '500',
				'icon_border_spacing'        => '50',
				'icon_animation'             => '',
				'title'                      => '',
				'link'                       => '',
				'hover_effect'               => 'style_1',
				'icon_color_hover'           => '',
				'icon_color_bg_hover'        => '',
				'icon_color_border_hover'    => '',
				'pos'                        => 'default',
				'box_min_height'             => '',
				'box_border_style'           => '',
				'box_border_width'           => '',
				'box_border_color'           => '',
				'box_bg_color'               => '',
				'info_box_shadow'            => '',
				'read_more'                  => 'none',
				'read_text'                  => 'Read More',
				'heading_tag'                => 'h3',
				'title_font'                 => '',
				'title_font_style'           => '',
				'title_font_size'            => '',
				'title_font_line_height'     => '',
				'title_font_color'           => '',
				'title_font_color_hover'     => '',
				'desc_font'                  => '',
				'desc_font_style'            => '',
				'desc_font_size'             => '',
				'desc_font_color'            => '',
				'desc_font_color_hover'      => '',
				'desc_font_line_height'      => '',
				'module_animation'           => '',
				'generic_box_bg_color'       => '',
				'generic_box_bg_color_hover' => '',
				'desc_margin_top'            => '',
				'el_class'                   => '',
				'css_info_box'               => '',
			), $atts, 'bsf-info-box' ) );
			$html             = $target = $suffix = $prefix = $title_style = $desc_style = $inf_design_style = '';
			$inf_design_style = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css_info_box, ' ' ), "bsf-info-box", $atts );
			$inf_design_style = esc_attr( $inf_design_style );

			$generic_id = 'aio-icon-component-' . rand( 1000, 9999 );

			if ( $info_box_shadow ) {
				$el_class .= ' with-shadow';
			}

			if ( $generic_box_bg_color != '' ) {
				$generic_box_style .= 'style="background-color:' . $generic_box_bg_color . ';"';
			}

			$box_icon = do_shortcode( '[just_icon icon_type="' . esc_attr( $icon_type ) . '" icon="' . esc_attr( $icon ) . '" icon_img="' . esc_attr( $icon_img ) . '" img_width="' . esc_attr( $img_width ) . '" icon_size="' . esc_attr( $icon_size ) . '" icon_color="' . esc_attr( $icon_color ) . '" icon_style="' . esc_attr( $icon_style ) . '" icon_color_bg="' . esc_attr( $icon_color_bg ) . '" icon_color_border="' . esc_attr( $icon_color_border ) . '"  icon_border_style="' . esc_attr( $icon_border_style ) . '" icon_border_size="' . esc_attr( $icon_border_size ) . '" icon_border_radius="' . esc_attr( $icon_border_radius ) . '" icon_border_spacing="' . esc_attr( $icon_border_spacing ) . '" icon_animation="' . esc_attr( $icon_animation ) . '"]' );
			$prefix   .= '<div id="' . $generic_id . '" class="aio-icon-component ' . esc_attr( $inf_design_style ) . ' ' . esc_attr( $css_class ) . ' ' . esc_attr( $el_class ) . ' ' . esc_attr( $hover_effect ) . '" ' . $generic_box_style . '>';
			$suffix   .= '</div> <!-- aio-icon-component -->';

			$ex_class = $ic_class = '';
			if ( $pos != '' ) {
				$ex_class .= $pos . '-icon';
				$ic_class = 'aio-icon-' . $pos;
			}

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . $module_animation . '"';
			}

			/* title */
			if ( $title_font != '' ) {
				$font_family = get_ultimate_font_family( $title_font );
				if ( $font_family != '' ) {
					$title_style .= 'font-family:\'' . $font_family . '\';';
				}
			}
			if ( $title_font_style != '' ) {
				$title_style .= get_ultimate_font_style( $title_font_style );
			}


			if ( is_numeric( $title_font_size ) ) {
				$title_font_size = 'desktop:' . $title_font_size . 'px;';
			}
			if ( is_numeric( $title_font_line_height ) ) {
				$title_font_line_height = 'desktop:' . $title_font_line_height . 'px;';
			}
			$info_box_id        = 'Info-box-wrap-' . rand( 1000, 9999 );
			$info_box_args      = array(
				'target'      => '#' . $info_box_id . ' .aio-icon-title', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $title_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $title_font_line_height
				),
			);
			$info_box_data_list = get_ultimate_vc_responsive_media_css( $info_box_args );

			if ( $title_font_color != '' ) {
				$title_style .= 'color:' . $title_font_color . ';';
			}

			/* description */
			if ( $desc_font != '' ) {
				$font_family = get_ultimate_font_family( $desc_font );
				if ( $font_family !== '' ) {
					$desc_style .= 'font-family:\'' . $font_family . '\';';
				}
			}
			if ( $desc_font_style != '' ) {
				$desc_style .= get_ultimate_font_style( $desc_font_style );
			}

			if ( is_numeric( $desc_font_size ) ) {
				$desc_font_size = 'desktop:' . $desc_font_size . 'px;';
			}
			if ( is_numeric( $desc_font_line_height ) ) {
				$desc_font_line_height = 'desktop:' . $desc_font_line_height . 'px;';
			}

			$info_box_desc_args      = array(
				'target'      => '#' . $info_box_id . ' .aio-icon-description', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $desc_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $desc_font_line_height
				),
			);
			$info_box_desc_data_list = get_ultimate_vc_responsive_media_css( $info_box_desc_args );
			if ( $desc_font_color != '' ) {
				$desc_style .= 'color:' . $desc_font_color . ';';
			}
			if ( $desc_margin_top != '' ) {
				$desc_style .= 'margin-top:' . $desc_margin_top . 'px;';
			}
			//enquque_ultimate_google_fonts($font_args);

			$box_style = $box_style_data = '';
			if ( $pos == 'square_box' || $pos == 'square_box_2' ) {
				if ( $box_min_height != '' ) {
					$box_style_data .= "data-min-height='" . esc_attr( $box_min_height ) . "px'";
				}
				if ( $box_border_color != '' ) {
					$box_style .= "border-color:" . $box_border_color . ";";
				}
				if ( $box_border_style != '' ) {
					$box_style .= "border-style:" . $box_border_style . ";";
				}
				if ( $box_border_width != '' ) {
					$box_style .= "border-width:" . $box_border_width . "px;";
				}
				if ( $box_bg_color != '' ) {
					$box_style .= "background-color:" . $box_bg_color . ";";
				}
			}
			$html .= '<div id="' . esc_attr( $info_box_id ) . '" class="aio-icon-box ' . esc_attr( $ex_class ) . ' ' . $animated . '" style="' . esc_attr( $box_style ) . '" ' . $box_style_data . ' ' . $animation . '>';

			if ( $pos == "heading-right" || $pos == "right" || $pos == "right-title" ) {
				if ( $pos == "right" ) {
					$html .= '<div class="aio-ibd-block" >';
				}
				if ( $title !== '' ) {
					$html        .= '<div class="aio-icon-header" >';
					$link_prefix = $link_sufix = '';
					if ( $link !== 'none' ) {
						if ( $read_more == 'title' ) {
							$href = vc_build_link( $link );

							$url         = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
							$target      = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
							$link_title  = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : '';
							$rel         = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';
							$link_prefix = '<a class="aio-icon-box-link" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>';
							$link_sufix  = '</a>';
						}
					}
					$html .= $link_prefix . '<' . $heading_tag . ' class="aio-icon-title ult-responsive" ' . $info_box_data_list . ' style="' . esc_attr( $title_style ) . '">' . $title . '</' . $heading_tag . '>' . $link_sufix;
					$html .= '</div> <!-- header -->';
				}
				if ( $pos !== "right" ) {
					if ( $icon !== 'none' || $icon_img !== '' ) {
						$html .= '<div class="' . esc_attr( $ic_class ) . '" >' . $box_icon . '</div>';
					}
				}
				if ( $content !== '' ) {
					$html .= '<div class="aio-icon-description ult-responsive" ' . $info_box_desc_data_list . ' style="' . esc_attr( $desc_style ) . '">';
					$html .= do_shortcode( $content );
					if ( $link !== 'none' ) {
						if ( $read_more == 'more' ) {
							$href = vc_build_link( $link );

							$url        = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
							$target     = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
							$link_title = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : '';
							$rel        = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';

							$more_link = '<a class="aio-icon-read x" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>';
							$more_link .= $read_text;
							$more_link .= '&nbsp;&raquo;';
							$more_link .= '</a>';
							$html      .= $more_link;
						}
					}
					$html .= '</div> <!-- description -->';
				}
				if ( $pos == "right" ) {
					$html .= '</div> <!-- aio-ibd-block -->';
					if ( $icon !== 'none' || $icon_img !== '' ) {
						$html .= '<div class="' . esc_attr( $ic_class ) . '">' . $box_icon . '</div>';
					}
				}

			} else {
				if ( $icon !== 'none' || $icon_img != '' ) {
					$html .= '<div class="' . esc_attr( $ic_class ) . '">' . $box_icon . '</div>';
				}
				if ( $pos == "left" ) {
					$html .= '<div class="aio-ibd-block">';
				}
				if ( $title !== '' ) {
					$html        .= '<div class="aio-icon-header" >';
					$link_prefix = $link_sufix = '';
					if ( $link !== 'none' ) {
						if ( $read_more == 'title' ) {
							$href = vc_build_link( $link );

							$url        = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
							$target     = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
							$link_title = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : '';
							$rel        = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';

							$link_prefix = '<a class="aio-icon-box-link" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>';
							$link_sufix  = '</a>';
						}
					}
					$html .= $link_prefix . '<' . $heading_tag . ' class="aio-icon-title ult-responsive" ' . $info_box_data_list . ' style="' . esc_attr( $title_style ) . '">' . $title . '</' . $heading_tag . '>' . $link_sufix;
					$html .= '</div> <!-- header -->';
				}
				if ( $content !== '' ) {
					$html .= '<div class="aio-icon-description ult-responsive" ' . $info_box_desc_data_list . ' style="' . esc_attr( $desc_style ) . '">';
					$html .= do_shortcode( $content );
					if ( $link !== 'none' ) {
						if ( $read_more == 'more' ) {
							$href = vc_build_link( $link );

							$url        = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
							$target     = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
							$link_title = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : '';
							$rel        = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';

							$more_link = '<a class="aio-icon-read xx" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>';
							$more_link .= $read_text;
							$more_link .= '&nbsp;&raquo;';
							$more_link .= '</a>';
							$html      .= $more_link;
						}
					}
					$html .= '</div> <!-- description -->';
				}
				if ( $pos == "left" ) {
					$html .= '</div> <!-- aio-ibd-block -->';
				}

			}


			$html .= '</div> <!-- aio-icon-box -->';
			if ( $link !== 'none' ) {
				if ( $read_more == 'box' ) {
					$href = vc_build_link( $link );

					$url        = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
					$target     = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
					$link_title = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : '';
					$rel        = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';

					$output = $prefix . '<a class="aio-icon-box-link" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>' . $html . '</a>' . $suffix;
				} else {
					$output = $prefix . $html . $suffix;
				}
			} else {
				$output = $prefix . $html . $suffix;
			}
			$is_preset = false; //Display settings for Preset
			if ( isset( $_GET['preset'] ) ) {
				$is_preset = true;
			}
			if ( $is_preset ) {
				$text = 'array ( ';
				foreach ( $atts as $key => $att ) {
					$text .= '<br/>	\'' . $key . '\' => \'' . $att . '\',';
				}
				if ( $content != '' ) {
					$text .= '<br/>	\'content\' => \'' . $content . '\',';
				}
				$text   .= '<br/>)';
				$output .= '<pre>';
				$output .= $text;
				$output .= '</pre>';
			}

			if ( $icon_color_hover != '' || $icon_color_bg_hover != '' || $icon_color_border_hover != '' || $title_font_color_hover != '' || $desc_font_color_hover != '' || $generic_box_bg_color_hover != '' ) {
				$style .= '<style type="text/css">';
				if ( $icon_color_hover != '' ) {
					$style .= '#' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .ult-just-icon-wrapper .aio-icon{color:' . esc_attr( $icon_color_hover ) . ' !important} ';
				}
				if ( $icon_color_bg_hover != '' ) {
					$style .= '#' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .ult-just-icon-wrapper .aio-icon, #' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .ult-just-icon-wrapper .aio-icon-img{background:' . esc_attr( $icon_color_bg_hover ) . ' !important} ';
				}
				if ( $icon_color_border_hover != '' ) {
					$style .= '#' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .ult-just-icon-wrapper .aio-icon, #' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .ult-just-icon-wrapper .aio-icon-img{border-color:' . esc_attr( $icon_color_border_hover ) . ' !important} ';
				}
				if ( $title_font_color_hover != '' ) {
					$style .= '#' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .aio-icon-header .aio-icon-title{color:' . esc_attr( $title_font_color_hover ) . ' !important} ';
				}
				if ( $desc_font_color_hover != '' ) {
					$style .= '#' . $generic_id . '.' . $hover_effect . ':hover #' . $info_box_id . ' .aio-icon-description{color:' . esc_attr( $desc_font_color_hover ) . ' !important} ';
				}
				if ( $generic_box_bg_color_hover != '' ) {
					$style .= '#' . $generic_id . ':hover{background-color:' . esc_attr( $generic_box_bg_color_hover ) . ' !important}';
				}
				$style .= '</style>';
			}

			if ( $style != '' ) {
				$output .= "<script type=\"text/javascript\">jQuery(document).ready(function(){jQuery('head').append('" . $style . "');});</script>";
			}

			return $output;
		}

		/* Add icon box Component*/
		function icon_box_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map(
					array(
						"name"                    => __( "Info Box", "adamas-vc-shortcodes" ),
						"base"                    => "bsf-info-box",
						"icon"                    => "vc_info_box",
						"class"                   => "info_box",
						"category"                => "Ultimate VC Addons",
						"description"             => __( "Adds icon box with custom font icon", "adamas-vc-shortcodes" ),
						"controls"                => "full",
						"show_settings_on_create" => true,
						"params"                  => array(
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon to display:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_type",
								"value"       => array(
									__( "Font Icon Manager", "adamas-vc-shortcodes" ) => "selector",
									__( "Custom Image Icon", "adamas-vc-shortcodes" ) => "custom",
								),
								"description" => __( "Use an existing font icon or upload a custom image.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "icon_manager",
								"class"       => "",
								"heading"     => __( "Select Icon ", "adamas-vc-shortcodes" ),
								"param_name"  => "icon",
								"value"       => "",
								"description" => __( "Click and select icon of your choice. If you can't find the one that suits for your purpose", "adamas-vc-shortcodes" ) . ", " . __( "you can", "adamas-vc-shortcodes" ) . " <a href='admin.php?page=bsf-font-icon-manager' target='_blank' rel='noopener'>" . __( "add new here", "adamas-vc-shortcodes" ) . "</a>.",
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "ult_img_single",
								"class"       => "",
								"heading"     => __( "Upload Image Icon:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_img",
								"value"       => "",
								"description" => __( "Upload the custom image icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Image Width", "adamas-vc-shortcodes" ),
								"param_name"  => "img_width",
								"value"       => 48,
								"min"         => 16,
								"max"         => 512,
								"suffix"      => "px",
								"description" => __( "Provide image width", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Size of Icon", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_size",
								"value"       => 32,
								"min"         => 12,
								"max"         => 72,
								"suffix"      => "px",
								"description" => __( "How big would you like it?", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color",
								"value"       => "#333333",
								"description" => __( "Give it a nice paint!", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_style",
								"value"       => array(
									__( "Simple", "adamas-vc-shortcodes" )            => "none",
									__( "Circle Background", "adamas-vc-shortcodes" ) => "circle",
									__( "Square Background", "adamas-vc-shortcodes" ) => "square",
									__( "Design your own", "adamas-vc-shortcodes" )   => "advanced",
								),
								"description" => __( "We have given three quick preset if you are in a hurry. Otherwise, create your own with various options.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Background Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_bg",
								"value"       => "#ffffff",
								"description" => __( "Select background color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "circle", "square", "advanced" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Border Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_style",
								"value"       => array(
									__( "None", "adamas-vc-shortcodes" )   => "",
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								"description" => __( "Select the border style for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Border Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_border",
								"value"       => "#333333",
								"description" => __( "Select border color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Width", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_size",
								"value"       => 1,
								"min"         => 1,
								"max"         => 10,
								"suffix"      => "px",
								"description" => __( "Thickness of the border.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Radius", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_radius",
								"value"       => 500,
								"min"         => 1,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "0 pixel value will create a square border. As you increase the value, the shape convert in circle slowly. (e.g 500 pixels).", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Background Size", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_spacing",
								"value"       => 50,
								"min"         => 30,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "Spacing from center of the icon till the boundary of border / background", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							/*array(
								"type" => "dropdown",
								"class" => "",
								"heading" => __("Animation","adamas-vc-shortcodes"),
								"param_name" => "icon_animation",
								"value" => array(
							 		__("No Animation","adamas-vc-shortcodes") => "",
									__("Swing","adamas-vc-shortcodes") => "swing",
									__("Pulse","adamas-vc-shortcodes") => "pulse",
									__("Fade In","adamas-vc-shortcodes") => "fadeIn",
									__("Fade In Up","adamas-vc-shortcodes") => "fadeInUp",
									__("Fade In Down","adamas-vc-shortcodes") => "fadeInDown",
									__("Fade In Left","adamas-vc-shortcodes") => "fadeInLeft",
									__("Fade In Right","adamas-vc-shortcodes") => "fadeInRight",
									__("Fade In Up Long","adamas-vc-shortcodes") => "fadeInUpBig",
									__("Fade In Down Long","adamas-vc-shortcodes") => "fadeInDownBig",
									__("Fade In Left Long","adamas-vc-shortcodes") => "fadeInLeftBig",
									__("Fade In Right Long","adamas-vc-shortcodes") => "fadeInRightBig",
									__("Slide In Down","adamas-vc-shortcodes") => "slideInDown",
									__("Slide In Left","adamas-vc-shortcodes") => "slideInLeft",
									__("Slide In Left","adamas-vc-shortcodes") => "slideInLeft",
									__("Bounce In","adamas-vc-shortcodes") => "bounceIn",
									__("Bounce In Up","adamas-vc-shortcodes") => "bounceInUp",
									__("Bounce In Down","adamas-vc-shortcodes") => "bounceInDown",
									__("Bounce In Left","adamas-vc-shortcodes") => "bounceInLeft",
									__("Bounce In Right","adamas-vc-shortcodes") => "bounceInRight",
									__("Rotate In","adamas-vc-shortcodes") => "rotateIn",
									__("Light Speed In","adamas-vc-shortcodes") => "lightSpeedIn",
									__("Roll In","adamas-vc-shortcodes") => "rollIn",
									),
								"description" => __("Like CSS3 Animations? We have several options for you!","adamas-vc-shortcodes")
						  	),*/
							// Icon Box Heading
							array(
								"type"             => "textfield",
								"class"            => "",
								"heading"          => __( "Title", "adamas-vc-shortcodes" ),
								"param_name"       => "title",
								"admin_label"      => true,
								"value"            => "",
								"description"      => __( "Provide the title for this icon box.", "adamas-vc-shortcodes" ),
								'edit_field_class' => 'vc_col-sm-8',
							),
							array(
								"type"             => "dropdown",
								"heading"          => __( "Tag", "adamas-vc-shortcodes" ),
								"param_name"       => "heading_tag",
								"value"            => array(
									__( "Default", "adamas-vc-shortcodes" ) => "h3",
									__( "H1", "adamas-vc-shortcodes" )      => "h1",
									__( "H2", "adamas-vc-shortcodes" )      => "h2",
									__( "H4", "adamas-vc-shortcodes" )      => "h4",
									__( "H5", "adamas-vc-shortcodes" )      => "h5",
									__( "H6", "adamas-vc-shortcodes" )      => "h6",
									__( "Div", "adamas-vc-shortcodes" )     => "div",
									__( "p", "adamas-vc-shortcodes" )       => "p",
									__( "span", "adamas-vc-shortcodes" )    => "span",
								),
								"description"      => __( "Default is H3", "adamas-vc-shortcodes" ),
								'edit_field_class' => 'vc_col-sm-4',
								// "group" => "Typography"
							),
							// Add some description
							array(
								"type"             => "textarea_html",
								"class"            => "",
								"heading"          => __( "Description", "adamas-vc-shortcodes" ),
								"param_name"       => "content",
								"value"            => "",
								"description"      => __( "Provide the description for this icon box.", "adamas-vc-shortcodes" ),
								"edit_field_class" => "ult_hide_editor_fullscreen vc_col-xs-12 vc_column wpb_el_type_textarea_html vc_wrapper-param-type-textarea_html vc_shortcode-param",
							),
							// Select link option - to box or with read more text
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Apply link to:", "adamas-vc-shortcodes" ),
								"param_name"  => "read_more",
								"value"       => array(
									__( "No Link", "adamas-vc-shortcodes" )           => "none",
									__( "Complete Box", "adamas-vc-shortcodes" )      => "box",
									__( "Box Title", "adamas-vc-shortcodes" )         => "title",
									__( "Display Read More", "adamas-vc-shortcodes" ) => "more",
								),
								"description" => __( "Select whether to use color for icon or not.", "adamas-vc-shortcodes" )
							),
							// Add link to existing content or to another resource
							array(
								"type"        => "vc_link",
								"class"       => "",
								"heading"     => __( "Add Link", "adamas-vc-shortcodes" ),
								"param_name"  => "link",
								"value"       => "",
								"description" => __( "Add a custom link or select existing page. You can remove existing link as well.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "read_more", "value" => array( "box", "title", "more" ) ),
							),
							// Link to traditional read more
							array(
								"type"        => "textfield",
								"class"       => "",
								"heading"     => __( "Read More Text", "adamas-vc-shortcodes" ),
								"param_name"  => "read_text",
								"value"       => "Read More",
								"description" => __( "Customize the read more text.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "read_more", "value" => array( "more" ) ),
							),
							// Hover Effect type
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Select Hover Effect type", "adamas-vc-shortcodes" ),
								"param_name"  => "hover_effect",
								"value"       => array(
									__( "No Effect", "adamas-vc-shortcodes" )                        => "style_1",
									__( "Icon Zoom", "adamas-vc-shortcodes" )                        => "style_2",
									__( "Icon Bounce Up", "adamas-vc-shortcodes" )                   => "style_3",
									__( "Change Icon Color and Background", "adamas-vc-shortcodes" ) => "style_4",
								),
								"description" => __( "Select the type of effct you want on hover", "smile" )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Select Icon Color on Hover", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_hover",
								"description" => __( "Set icon color on hover. Doesn't work for image icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "hover_effect", "value" => array( "style_4" ) )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Select Icon Background Color on Hover", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_bg_hover",
								"description" => __( "Set icon background color on hover.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "hover_effect", "value" => array( "style_4" ) )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Select Icon Border Color on Hover", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_border_hover",
								"description" => __( "Set icon border color on hover.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "hover_effect", "value" => array( "style_4" ) )
							),
							// Position the icon box
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Box Style", "adamas-vc-shortcodes" ),
								"param_name"  => "pos",
								"value"       => array(
									__( "Icon at Left with heading", "adamas-vc-shortcodes" )  => "default",
									__( "Icon at Right with heading", "adamas-vc-shortcodes" ) => "heading-right",
									__( "Icon at Left", "adamas-vc-shortcodes" )               => "left",
									__( "Icon at Right", "adamas-vc-shortcodes" )              => "right",
									__( "Icon at Top", "adamas-vc-shortcodes" )                => "top",
									__( "Icon at Left aligned with title", "vc" )     => "left-title",
									__( "Icon at Right aligned with title", "vc" )    => "right-title",
									__( "Boxed Style", "adamas-vc-shortcodes" )                => "square_box",
									__( "Boxed Style 2", "adamas-vc-shortcodes" )              => "square_box_2",
								),
								"description" => __( "Select icon position. Icon box style will be changed according to the icon position.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Description top margin", "adamas-vc-shortcodes" ),
								"param_name"  => "desc_margin_top",
								"value"       => "",
								"suffix"      => "px",
								"dependency"  => Array( "element" => "pos", "value" => array( "left-title", "left-title" ) ),
								"description" => __( "Set top margin for description. Default - -10px.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Box Min Height", "adamas-vc-shortcodes" ),
								"param_name"  => "box_min_height",
								"value"       => "",
								"suffix"      => "px",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box" ) ),
								"description" => __( "Select Min Height for Box.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Box Border Style", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_style",
								"value"       => array(
									__( "None", "adamas-vc-shortcodes" )   => "",
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Border Style for box border.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "checkbox",
								"class"       => "",
								"heading"     => __( "Enable Box Shadow", "adamas-vc-shortcodes" ),
								"param_name"  => "info_box_shadow",
								"description" => __( "Check this if you want to set shadow for info box.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box_2" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Box Border Width", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_width",
								"value"       => "",
								"suffix"      => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Width for Box Border.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Box Border Color", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_color",
								"value"       => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Border color for border box.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Box Background Color", "adamas-vc-shortcodes" ),
								"param_name"  => "box_bg_color",
								"value"       => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Box background color.", "adamas-vc-shortcodes" )
							),
							array(
								'type'        => 'colorpicker',
								'class'       => '',
								'heading'     => __( 'Generic Box Background Color', 'adamas-vc-shortcodes' ),
								'param_name'  => 'generic_box_bg_color',
								'value'       => '',
								'description' => __( 'Select generic box background color.', 'adamas-vc-shortcodes' ),
							),
							array(
								'type'        => 'colorpicker',
								'class'       => '',
								'heading'     => __( 'Generic Box Background Color on hover', 'adamas-vc-shortcodes' ),
								'param_name'  => 'generic_box_bg_color_hover',
								'value'       => '',
								'description' => __( 'Select generic box background color on hover.', 'adamas-vc-shortcodes' ),
							),
							// Animation
							array(
								'type'        => 'dropdown',
								'class'       => '',
								'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
								'param_name'  => 'module_animation',
								'value'       => st_adamas_animations_list(),
								'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
							),
							// Customize everything
							array(
								"type"        => "textfield",
								"class"       => "",
								"heading"     => __( "Extra Class", "adamas-vc-shortcodes" ),
								"param_name"  => "el_class",
								"value"       => "",
								"description" => __( "Add extra class name that will be applied to the icon box, and you can use this class for your customizations.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"             => "ult_param_heading",
								"param_name"       => "title_text_typography",
								"heading"          => __( "Title settings", "adamas-vc-shortcodes" ),
								"value"            => "",
								"group"            => "Typography",
								'edit_field_class' => 'ult-param-heading-wrapper no-top-margin vc_column vc_col-sm-12',
							),
							array(
								"type"        => "dropdown",
								"heading"     => __( "Tag", "adamas-vc-shortcodes" ),
								"param_name"  => "heading_tag",
								"value"       => array(
									__( "Default", "adamas-vc-shortcodes" ) => "h3",
									__( "H1", "adamas-vc-shortcodes" )      => "h1",
									__( "H2", "adamas-vc-shortcodes" )      => "h2",
									__( "H4", "adamas-vc-shortcodes" )      => "h4",
									__( "H5", "adamas-vc-shortcodes" )      => "h5",
									__( "H6", "adamas-vc-shortcodes" )      => "h6",
									__( "Div", "adamas-vc-shortcodes" )     => "div",
									__( "p", "adamas-vc-shortcodes" )       => "p",
									__( "span", "adamas-vc-shortcodes" )    => "span",
								),
								"description" => __( "Default is H3", "adamas-vc-shortcodes" ),
								"group"       => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts",
								"heading"    => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name" => "title_font",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "title_font_style",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "title_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "title_font_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "title_font_color",
								"heading"    => __( "Color", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "title_font_color_hover",
								"heading"    => __( "Color on hover", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"             => "ult_param_heading",
								"param_name"       => "desc_text_typography",
								"heading"          => __( "Description settings", "adamas-vc-shortcodes" ),
								"value"            => "",
								"group"            => "Typography",
								'edit_field_class' => 'ult-param-heading-wrapper vc_column vc_col-sm-12',
							),
							array(
								"type"       => "ultimate_google_fonts",
								"heading"    => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name" => "desc_font",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "desc_font_style",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "desc_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "desc_font_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "desc_font_color",
								"heading"    => __( "Color", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "desc_font_color_hover",
								"heading"    => __( "Color on hover", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"             => "ult_param_heading",
								"text"             => "<span style='display: block;'><a href='http://bsf.io/kqzzi' target='_blank' rel='noopener'>" . __( "Watch Video Tutorial", "adamas-vc-shortcodes" ) . " &nbsp; <span class='dashicons dashicons-video-alt3' style='font-size:30px;vertical-align: middle;color: #e52d27;'></span></a></span>",
								"param_name"       => "notification",
								'edit_field_class' => 'ult-param-important-wrapper ult-dashicon ult-align-right ult-bold-font ult-blue-font vc_column vc_col-sm-12',
							),
							array(
								'type'             => 'css_editor',
								'heading'          => __( 'Css', 'adamas-vc-shortcodes' ),
								'param_name'       => 'css_info_box',
								'group'            => __( 'Design ', 'adamas-vc-shortcodes' ),
								'edit_field_class' => 'vc_col-sm-12 vc_column no-vc-background no-vc-border creative_link_css_editor',
							),
						) // end params array
					) // end vc_map array
				); // end vc_map
			} // end function check 'vc_map'
		}// end function icon_box_init

		function icon_box_scripts() {
			Ultimate_VC_Addons::ultimate_register_style( 'info-box-style', 'info-box' );

			Ultimate_VC_Addons::ultimate_register_script( 'info_box_js', 'info-box' );
		}
	}//Class end
}
if ( class_exists( 'AIO_Icons_Box' ) ) {
	$AIO_Icons_Box = new AIO_Icons_Box;
}
