<?php

$el_class = $column_amount = $posts_module_layout = $column_padding = $posts_items_amount = $post_image = $posts_date_only = $module_animation = $animation = $animated = $inner_animated = $output = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'column_amount'       => '',
	'posts_module_layout' => '',
	'column_padding'      => '',
	'posts_items_amount'  => '',
	'posts_date_only'     => '',
	'module_animation'    => '',
	'el_class'            => '',
), $atts ) );

if ( $module_animation ) {
	$animated       .= ' st-animation';
	$animation      .= 'data-animation="' . esc_attr( $module_animation ) . '"';
	$inner_animated .= 'data-animated=".st-posts-module-single"';
}

$id = uniqid( 'st-posts-' );

if ( empty( $posts_module_layout ) ) {
	$posts_module_layout = 'fitRows';
}

if ( empty( $column_amount ) ) {
	$column_amount = 'three-column';
}

if ( empty( $posts_items_amount ) ) {
	$posts_items_amount = - 1;
}

if ( ! empty( $column_padding ) ) {
	$el_class .= ' ' . $column_padding;
}

if ( $column_amount == 'one-column' ) {
	$width = 1920;
} elseif ( $column_amount == 'two-column' ) {
	$width = 960;
} elseif ( $column_amount == 'three-column' ) {
	$width = 640;
} else {
	$width = 480;
}

if ( strcmp( $posts_module_layout, 'fitRows' ) === 0 ) {
	if ( $column_amount == 'one-column' ) {
		$height = 1280;
	} elseif ( $column_amount == 'two-column' ) {
		$height = 800;
	} elseif ( $column_amount == 'three-column' ) {
		$height = 533;
	} else {
		$height = 400;
	}
} else {
	$height = 800;
}

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-posts-module ' . esc_attr( $css_class ) . ' ' . esc_attr( $posts_module_layout ) . ' ' . esc_attr( $column_amount ) . ' ' . $animated . '" id="' . esc_attr( $id ) . '" ' . $inner_animated . ' ' . $animation . '>';
$posts  = new WP_Query( array( 'posts_per_page' => $posts_items_amount ) );
while ( $posts->have_posts() ) : $posts->the_post();
	$output .= '<article class="st-posts-module-single ' . get_post_format( get_the_ID() ) . '">';

	if ( has_post_format( 'quote' ) ) {
		$quote_author = get_post_meta( get_the_ID(), 'st_quote_post_author', true );

		$output .= '<a href="' . esc_url( get_permalink() ) . '"><div class="st-posts-module-quote">';
		$output .= wp_kses_post( get_the_content() );
		$output .= '<h3>' . esc_attr( get_the_title() ) . '</h3>';
		if ( $quote_author ) {
			$output .= '<div class="st-posts-module-quote-author">' . esc_html( $quote_author ) . '</div>';
		}
		$output .= '</div></a>';
	} else {
		switch ( true ) {
			// Gallery Post Format
			case has_post_format( 'gallery' ):
				$img_array = get_post_meta( get_the_ID(), 'st_gallery_post_images', 1 );
				if ( ! empty( $img_array ) ) {
					$gallery_images = $img_array;
				}

				if ( has_post_thumbnail() ) {
					$image_resize = true;

					$image_id  = get_post_thumbnail_id();
					$image_url = wp_get_attachment_url( $image_id, 'full' );

					$post_image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
					if ( ! $post_image ) {
						$post_image = $image_url;
					}
				}

				if ( ! empty( $gallery_images ) ) {
					$output .= '<div class="st-posts-module-gallery"><div class="st-posts-module-gallery-inner">';
					foreach ( $gallery_images as $gallery_image_id => $gallery_image_url ) {
						$image_resize = true;

						$gallery_image_alt = get_post_meta( $gallery_image_id, '_wp_attachment_image_alt', true );

						$gallery_image = st_adamas_aq_resize( $gallery_image_url, $width, $height, $image_resize, true, true );
						if ( ! $gallery_image ) {
							$gallery_image = $gallery_image_url;
						}

						$output .= '<img src="' . esc_url( $gallery_image ) . '" alt="' . esc_html( $gallery_image_alt ) . '" />';
					}
					$output .= '</div>'; // st-posts-module-gallery-inner
					$output .= '<div class="post-gallery-progress"><div class="progress"></div></div>';
					$output .= '</div>'; // st-posts-module-gallery
				} elseif ( has_post_thumbnail() ) {
					$output .= '<div class="st-posts-module-thumbnail"><img src="' . esc_url( $post_image ) . '" alt="' . esc_attr( get_the_title() ) . '" />';
					$output .= '</div>'; // st-posts-module-thumbnail
				}
				break;
			// Video Post Format
			case has_post_format( 'video' ):
				if ( has_post_thumbnail() ) {
					$image_resize = true;

					$image_id  = get_post_thumbnail_id();
					$image_url = wp_get_attachment_url( $image_id, 'full' );

					$post_image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
					if ( ! $post_image ) {
						$post_image = $image_url;
					}
				}

				$video_url = get_post_meta( get_the_ID(), 'st_video_post_video_url', 1 );
				if ( ! empty( $video_url ) ) {
					$video = esc_url( $video_url );
				}

				if ( ! empty( $video ) ) {
					$output .= '<div class="st-posts-module-video">' . wp_oembed_get( $video ) . '</div>';
				} elseif ( has_post_thumbnail() ) {
					$output .= '<div class="st-posts-module-thumbnail"><img src="' . esc_url( $post_image ) . '" alt="' . esc_attr( get_the_title() ) . '" />';
					$output .= '</div>'; // st-posts-module-thumbnail
				}
				break;
			// Audio Post Format
			case has_post_format( 'audio' ):
				if ( has_post_thumbnail() ) {
					$image_resize = true;

					$image_id  = get_post_thumbnail_id();
					$image_url = wp_get_attachment_url( $image_id, 'full' );

					$post_image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
					if ( ! $post_image ) {
						$post_image = $image_url;
					}
				}

				$audio_url = get_post_meta( get_the_ID(), 'st_audio_post_audio_url', 1 );
				if ( ! empty( $audio_url ) ) {
					$audio = esc_url( $audio_url );
				}

				if ( ! empty( $audio ) ) {
					$output .= '<div class="st-posts-module-audio">' . wp_oembed_get( $audio ) . '</div>';
				} elseif ( has_post_thumbnail() ) {
					$output .= '<div class="st-posts-module-thumbnail"><img src="' . esc_url( $post_image ) . '" alt="' . esc_attr( get_the_title() ) . '" />';
					$output .= '</div>'; // st-posts-module-thumbnail
				}
				break;
			// Standard Post
			default:
				if ( has_post_thumbnail() ) {
					$thumbnail = get_post_thumbnail_id();
					$image_url = wp_get_attachment_url( $thumbnail, 'full' );
					if ( strcmp( $posts_module_layout, 'fitRows' ) === 0 ) {
						$post_image = st_adamas_aq_resize( $image_url, $width, $height, true, true, true );
					} else {
						$post_image = st_adamas_aq_resize( $image_url, $width, $height, false, true, true );
					}
					if ( ! $post_image ) {
						$post_image = $image_url;
					}

					$output .= '<div class="st-posts-module-thumbnail"><a href="' . esc_url( get_permalink() ) . '"><div class="st-posts-module-overlay"><div class="overlay-inner-icon"></div><div class="overlay-inner-left"></div><div class="overlay-inner-right"></div></div><img src="' . esc_url( $post_image ) . '" alt="' . esc_attr( get_the_title() ) . '" />';
					$output .= '</a></div>'; // st-posts-module-thumbnail
				}
		}

		$output .= '<div class="st-posts-module-title"><a href="' . esc_url( get_permalink() ) . '">';
		$output .= '<h3>' . esc_attr( get_the_title() ) . '</h3>';
		$output .= '</a></div>'; // st-posts-module-title
		$output .= '<time class="st-posts-module-date" datetime="' . get_the_date( 'Y-m-d' ) . '">';
		$output .= get_the_date( get_option( 'date_format' ) );
		$output .= '</time>'; // st-posts-module-date
		if ( $posts_date_only ) {
			//
		} else {
			$output .= '<div class="st-posts-module-post-author"><span>' . esc_html__( 'Posted by', 'adamas-vc-shortcodes' ) . ':</span> ';

			if ( ( get_the_author_meta( 'display_name', get_post( get_the_ID() )->post_author ) ) != '0' ) {
				$output .= '<span>' . get_the_author_meta( 'display_name', get_post( get_the_ID() )->post_author ) . '</span>';
			} else {
				$output .= '<span>' . get_the_author() . '</span>';
			}
			$output .= '</div>'; // st-posts-module-post-author
			$output .= '<div class="st-posts-module-post-comments-amount"><span>' . esc_html__( 'Comments', 'adamas-vc-shortcodes' ) . ':</span> <span>' . get_comments_number( '0', '1', '%' ) . '</span></div>';
		}
	}
	$output .= '</article>'; // st-posts-module-single
endwhile;
wp_reset_postdata();
$output .= '</div>'; // st-posts

wp_enqueue_script( 'isotope', get_template_directory_uri() . '/assets/js/isotope.pkgd.min.js', false, null, true );
wp_enqueue_script( 'posts_masonry', get_template_directory_uri() . '/assets/js/posts.masonry.js', array(
	'jquery',
	'isotope'
), null, true );

$output .= '<script type="text/javascript">';
$output .= '(function($){';
$output .= '"use strict";';
$output .= '$(document).ready(function(){';
$output .= '$("#' . esc_js( $id ) . '").StPostsModule("' . esc_js( $posts_module_layout ) . '");';
$output .= '});';
$output .= '})(jQuery);';
$output .= '</script>';

echo $output;