<?php

$title  = $values = $units = $bgcolor = $css = $custombgcolor = $customtxtcolor = $options = $progress_bar_alignment = $progress_bar_bg_color = $el_class = $lighter_bg_color = $max_value = '';
$output = '';
$atts   = vc_map_get_attributes( $this->getShortcode(), $atts );
$atts   = $this->convertAttributesToNewProgressBar( $atts );

extract( $atts );
wp_enqueue_script( 'waypoints' );

$el_class = $this->getExtraClass( $el_class );

if ( $progress_bar_alignment === 'right' ) {
	$pos = 'right';
} else {
	$pos = '';
}

$bar_options = array();
$options     = explode( ',', $options );
if ( in_array( 'animated', $options ) ) {
	$bar_options[] = 'animated';
}
if ( in_array( 'striped', $options ) ) {
	$bar_options[] = 'striped';
}

if ( $progress_bar_bg_color !== '' ) {
	$lighter_bg_color = ' style="background: ' . $progress_bar_bg_color . '"';
}

if ( 'custom' === $bgcolor && '' !== $custombgcolor ) {
	$custombgcolor = ' style="' . vc_get_css_color( 'background-color', $custombgcolor ) . '"';
	if ( '' !== $customtxtcolor ) {
		$customtxtcolor = ' style="' . vc_get_css_color( 'color', $customtxtcolor ) . '"';
	}
	$bgcolor = '';
} else {
	$custombgcolor  = '';
	$customtxtcolor = '';
	$bgcolor        = 'vc_progress-bar-color-' . esc_attr( $bgcolor );
	$el_class       .= ' ' . $bgcolor;
}

$class_to_filter = 'vc_progress_bar wpb_content_element';
$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' ) . $this->getExtraClass( $el_class );
$css_class       = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $class_to_filter, $this->settings['base'], $atts );

$output = '<div class="' . esc_attr( $css_class ) . '">';

$output .= wpb_widget_title( array( 'title' => $title, 'extraclass' => 'wpb_progress_bar_heading' ) );

$values           = (array) vc_param_group_parse_atts( $values );
$max_value        = 0.0;
$graph_lines_data = array();
foreach ( $values as $data ) {
	$new_line              = $data;
	$new_line['value']     = isset( $data['value'] ) ? $data['value'] : 0;
	$new_line['label']     = isset( $data['label'] ) ? $data['label'] : '';
	$new_line['bgcolor']   = isset( $data['color'] ) && 'custom' !== $data['color'] ? '' : $custombgcolor;
	$new_line['max_value'] = isset( $data['max_value'] ) ? $data['max_value'] : 100.00;
	$new_line['txtcolor']  = isset( $data['color'] ) && 'custom' !== $data['color'] ? '' : $customtxtcolor;
	if ( isset( $data['customcolor'] ) && ( ! isset( $data['color'] ) || 'custom' === $data['color'] ) ) {
		$new_line['bgcolor'] = ' style="background-color: ' . esc_attr( $data['customcolor'] ) . ';"';
	}
	if ( isset( $data['customtxtcolor'] ) && ( ! isset( $data['color'] ) || 'custom' === $data['color'] ) ) {
		$new_line['txtcolor'] = ' style="color: ' . esc_attr( $data['customtxtcolor'] ) . ';"';
	}

	if ( $max_value < (float) $new_line['value'] ) {
		$max_value = $new_line['value'];
	}
	$graph_lines_data[] = $new_line;
}

foreach ( $graph_lines_data as $line ) {
	$max_value = $line['max_value'];
	$unit      = $line['value'];
	$output    .= '<div class="vc_label ' . $pos . '"' . $line['txtcolor'] . '>' . $line['label'] . '</div>';
	$output    .= '<div class="vc_general vc_single_bar ' . $pos . ( ( isset( $line['color'] ) && 'custom' !== $line['color'] ) ?
			' vc_progress-bar-color-' . $line['color'] : '' )
	              . '"' . $lighter_bg_color . '>';
//	if ( $max_value > 100.00 ) {
	$percentage_value = round( (float) $line['value'] / $max_value * 100, 4 );
//	} else {
//		$percentage_value = $line['value'];
//	}
	$output .= '<span class="vc_bar ' . esc_attr( implode( ' ', $bar_options ) ) . '" data-percentage-value="' . esc_attr( $percentage_value ) . '" data-value="' . esc_attr( $line['value'] ) . '"' . $line['bgcolor'] . '>' . $unit . $units . '</span>';
	$output .= '</div>';
}

$output .= '</div>';

echo $output;
