<?php
/**
 * Raw Field.
 *
 * @package     ReduxFramework/Fields
 * @author      Dovy Paukstys & Kevin Provance (kprovance)
 * @version     4.0.0
 */

defined( 'ABSPATH' ) || exit;

if ( ! class_exists( 'Redux_Raw', false ) ) {

	/**
	 * Class Redux_Raw
	 */
	class Redux_Raw extends Redux_Field {

		/**
		 * Field Render Function.
		 * Takes the vars and outputs the HTML for the field in the settings
		 *
		 * @since ReduxFramework 1.0.0
		 */
		public function render() {
			if ( ! empty( $this->field['include'] ) && file_exists( $this->field['include'] ) ) {
				require_once $this->field['include'];
			}

			if ( isset( $this->field['content_path'] ) && ! empty( $this->field['content_path'] ) && file_exists( $this->field['content_path'] ) ) {
				$this->field['content'] = $this->parent->filesystem->execute( 'get_contents', $this->field['content_path'] );
			}

			if ( ! empty( $this->field['content'] ) && isset( $this->field['content'] ) ) {
				if ( isset( $this->field['markdown'] ) && true === $this->field['markdown'] && ! empty( $this->field['content'] ) ) {
					require_once get_theme_file_path( '/admin/redux-framework/inc/fields/raw/parsedown.php' );
					$parsedown = new Parsedown();

					echo( wp_kses_post( $parsedown->text( $this->field['content'] ) ) ); // phpcs:ignore WordPress.Security.EscapeOutput
				} else {
					echo( wp_kses_post( $this->field['content'] ) ); // phpcs:ignore WordPress.Security.EscapeOutput
				}
			}

			// phpcs:ignore WordPress.NamingConventions.ValidHookName
			do_action( 'redux-field-raw-' . $this->parent->args['opt_name'] . '-' . $this->field['id'] );
		}
	}
}

class_alias( 'Redux_Raw', 'ReduxFramework_Raw' );
