(function ($) {
    "use strict";
    $(document).ready(function () {
        var pageNum = parseInt(st_ajax_data.startPage) + 1;
        var max = parseInt(st_ajax_data.maxPages);
        var nextLink = st_ajax_data.nextLink;
        var container = st_ajax_data.container;
        var $container = $(container);
        var $loadmoreanimation = $('.st-load-more-animation');
        var ready = true;

        function removeLoad() {
            $loadmoreanimation.removeClass('active');
        }

        $(window).bind('scroll', function (e) {
            e.preventDefault();
            var divTopOffset = $('.blog-articles').offset().top,
                divHeight = $('.blog-articles').outerHeight(),
                windowHeight = $(window).height(),
                scrollTop = $(this).scrollTop();
            if (ready && pageNum <= max && scrollTop > (divTopOffset + divHeight - windowHeight)) {
                ready = false;
                $loadmoreanimation.addClass('active');
                $.ajax({
                    type: 'GET',
                    url: nextLink,
                    dataType: 'html',
                    complete: function (XMLHttpRequest) {

                        pageNum++;
                        if (nextLink.indexOf('paged') != -1) {
                            nextLink = nextLink.replace(/\paged\=[0-9]?/, 'paged=' + pageNum);
                        } else {
                            nextLink = nextLink.replace(/\/page\/[0-9]?/, '/page/' + pageNum);
                        }

                        if ($(XMLHttpRequest.responseText).find(container).length > 0) {
                            $(XMLHttpRequest.responseText).find(container).children('article.post').each(function () {
                                var $newItems = $(this);
                                $newItems.imagesLoaded(function () {
                                    $newItems.find(".post-sharing-inner").jsSocials({
                                        shares: ["facebook", "googleplus", "linkedin", "pinterest", "twitter"],
                                        showLabel: false,
                                        showCount: false,
                                    });
                                    $container.isotope('insert', $newItems);

                                    var $gallery = $newItems.find(".post-gallery");
                                    if ($('body').hasClass('rtl')) {
                                        $gallery.slick({
                                            rows: 0,
                                            slidesToShow: 1,
                                            slidesToScroll: 1,
                                            rtl: true,
                                        });
                                    } else {
                                        $gallery.slick({
                                            rows: 0,
                                            slidesToShow: 1,
                                            slidesToScroll: 1,
                                        });
                                    }

                                    var time = 7;
                                    var $bar, isPause, tick, percentTime;

                                    $bar = $('.post-gallery-progress .progress');

                                    function startProgressbar() {
                                        resetProgressbar();
                                        percentTime = 0;
                                        isPause = false;
                                        tick = setInterval(interval, 10);
                                        $bar.addClass('loaded');
                                    }

                                    $('.post-gallery').on({
                                        mouseenter: function () {
                                            isPause = true;
                                        },
                                        mouseleave: function () {
                                            isPause = false;
                                        }
                                    });

                                    function interval() {
                                        if (isPause === false) {
                                            percentTime += 1 / (time + 0.1);
                                            $bar.css({width: percentTime + "%"});
                                            if (percentTime >= 100) {
                                                $gallery.slick('slickNext');
                                                startProgressbar();
                                            }
                                        }
                                    }

                                    function resetProgressbar() {
                                        $bar.css({width: 0 + '%'});
                                        clearTimeout(tick);
                                    }

                                    setTimeout(function () {
                                        $('.blog-articles').each(function () {
                                            var $art = $(this).find('article .post-inner');
                                            var $title = $art.find('.post-title');
                                            var $innerMedia = $art.find('.post-thumbnail img, .post-gallery, .post-audio iframe, .post-video iframe');
                                            var $excerpt = $art.find('.post-content');

                                            $art.matchHeight();
                                            $title.matchHeight();
                                            $excerpt.matchHeight();
                                            $innerMedia.matchHeight();
                                        });
                                        $container.isotope('layout');
                                        if (!$bar.hasClass('loaded')) {
                                            startProgressbar();
                                        }
                                    }, 500);
                                    removeLoad();
                                });
                            });
                        }
                    }
                }).always(function () {
                    ready = true;
                });
            }
        });
    });
})(jQuery);