/*
 * Theme main scripts
 */

(function($) {
  'use strict';
  $(document).ready(function() {

    // Animsition page transitions
    try {
      $('.animsition').animsition({
        inClass: 'fade-in',
        outClass: 'fade-out',
        inDuration: 400,
        outDuration: 400,
        linkElement: 'a:not(.wcml_currency_switcher a):not(.ajax_add_to_cart):not(.add_to_wishlist):not(.compare):not([target="_blank"]):not([href*="#"]):not([href*="admin-ajax.php"]):not([href^="tel\\:"]):not([href^="mailto\\:"]):not([href^="callTo\\:"]):not(.st-video-popup-link)',
        loading: true,
        loadingParentElement: 'body',
        loadingClass: 'animsition-loading',
        loadingInner: '',
        timeout: false,
        timeoutCountdown: 5000,
        onLoadEvent: true,
        browser: ['animation-duration', '-webkit-animation-duration'],
        overlay: false,
        overlayClass: 'animsition-overlay-slide',
        overlayParentElement: 'body',
        transition: function(url) {
          window.location.href = url;
        },
      });
    } catch (e) {
      $.noop();
    }

    // Activity Grid Mozilla and MSIE styles
    var sBrowser, sUsrAg = navigator.userAgent;
    if (sUsrAg.indexOf('Chrome') > -1) {
      sBrowser = 'Google Chrome';
    } else if (sUsrAg.indexOf('Safari') > -1) {
      sBrowser = 'Apple Safari';
    } else if (sUsrAg.indexOf('Opera') > -1) {
      sBrowser = 'Opera';
    } else if (sUsrAg.indexOf('Firefox') > -1) {
      sBrowser = 'Mozilla Firefox';
    } else if (sUsrAg.indexOf('MSIE') > -1) {
      sBrowser = 'Microsoft Internet Explorer';
    } else if (sUsrAg.indexOf('Trident') > -1) {
      sBrowser = 'Microsoft Internet Explorer';
    }

    if (sBrowser === 'Microsoft Internet Explorer' ||
        navigator.userAgent.indexOf('Edge') >= 0) {
      $('.st-activity-grid-item').
          removeClass('st-activity-grid-item').
          addClass('st-activity-grid-item-moz-ie');
    }

    // Smooth scrolling for one page header navigation
    $('nav.header-navigation a[href*="#"]:not([href="#"])').
        on('click', function() {
          if (location.pathname.replace(/^\//, '') ===
              this.pathname.replace(/^\//, '') && location.hostname ===
              this.hostname) {
            var target = $(this.hash);
            moveHashUrl(target);
            return false;
          }

          function moveHashUrl(target) {
            var headerHeight = $('.header-wrapper').height();
            target = target !== undefined ? target.offset().top : '';
            if ($('.header-wrapper').hasClass('sticky')) {
              $('html,body').animate({scrollTop: target - headerHeight}, 1000);
            } else {
              $('html,body').animate({scrollTop: target}, 1000);
            }
          }
        });

    // Smooth scrolling for page navigation
    $('.st-page-navigation-item a[href*="#"]:not([href="#"]), .st-pyramid>a[href*="#"]:not([href="#"])').
        on('click', function() {
          if (location.pathname.replace(/^\//, '') ==
              this.pathname.replace(/^\//, '') && location.hostname ==
              this.hostname) {
            var target = $(this.hash);
            moveHashUrl(target);
            return false;
          }

          function moveHashUrl(target) {
            var headerHeight = $('.header-wrapper').height();
            target = target !== undefined ? target.offset().top : '';
            if ($('.header-wrapper').hasClass('sticky')) {
              $('html,body').animate({scrollTop: target - headerHeight}, 1000);
            } else {
              $('html,body').animate({scrollTop: target}, 1000);
            }
          }
        });

    // Activity Grid Button Mozilla and MSIE
    var $activityGridItem = $('.st-activity-grid-item-moz-ie');
    $activityGridItem.each(function() {
      var $this = $(this);
      var $readmore, $button, $buttonText, $descbg, $desc;
      $readmore = $this.find('.st-activity-read-more');
      $button = $readmore.find('a');
      $buttonText = $button.find('span');
      $descbg = $(this).find('.st-activity-grid-desc');
      $desc = $(this).find('.st-activity-grid-desc>div');
      $button.on('click touchstart', function(e) {
        e.preventDefault();
        $descbg.toggleClass('active');
        setTimeout(activityDesc, 300);
        $button.toggleClass('active');
        $readmore.hide().delay(400).fadeIn(400);
        $buttonText.text(st_localize_script.hide);
        if (!($descbg).hasClass('active')) {
          $buttonText.text(st_localize_script.more_info);
        }
      });

      function activityDesc() {
        $desc.toggleClass('active');
      }

      $buttonText.text(st_localize_script.more_info);
    });

    // Activity Grid Button
    var $activityGridItem = $('.st-activity-grid-item');
    $activityGridItem.each(function() {
      var $this = $(this);
      var $readmore, $button, $buttonText, $descbg, $desc;
      $readmore = $this.find('.st-activity-read-more');
      $button = $readmore.find('a');
      $buttonText = $button.find('span');
      $descbg = $(this).find('.st-activity-grid-desc');
      $desc = $(this).find('.st-activity-grid-desc>div');
      $button.on('click touchstart', function(e) {
        e.preventDefault();
        $descbg.toggleClass('active');
        setTimeout(activityDesc, 300);
        $button.toggleClass('active');
        $readmore.hide().delay(400).fadeIn(400);
        $buttonText.text(st_localize_script.hide);
        if (!($descbg).hasClass('active')) {
          $buttonText.text(st_localize_script.more_info);
        }
      });

      function activityDesc() {
        $desc.toggleClass('active');
      }

      $buttonText.text(st_localize_script.more_info);
    });

    // Mobile menu toggle
    var $mobMenuButton = $('#mobile-menu-button');
    var $menuicon = $('#icon-mobile-menu');
    var $iconbars = $menuicon.find('a>div');
    if ($('body').hasClass('rtl')) {
      $mobMenuButton.sidr({
        name: 'mob-menu',
        source: '#mob-menu',
        displace: false,
        side: 'right',
        onOpen: function() {
          $iconbars.addClass('active');
        },
        onClose: function() {
          $iconbars.removeClass('active');
        },
      });
    } else {
      $mobMenuButton.sidr({
        name: 'mob-menu',
        source: '#mob-menu',
        displace: false,
        onOpen: function() {
          $iconbars.addClass('active');
        },
        onClose: function() {
          $iconbars.removeClass('active');
        },
      });
    }

    // Megamenu
    $('.header-wrapper .menu-main-menu-container > ul > li > ul:not(:has(ul))').
        addClass('ul-child');

    $('.sub-menu-columns').each(function() {
      var $this = $(this),
          columnMenuWidth = $this.attr('data-menu-width');
      if (columnMenuWidth) {
        $this.css('width', columnMenuWidth);
      }
    });

    var mainLi = $('.header-wrapper nav > ul > li');
    var childLi = $('.header-wrapper nav > ul > li > ul > li');
    var childUl = $('.header-wrapper nav > ul > li > ul');
    var childSubLi = $('.header-wrapper nav > ul > li > ul > li > ul > li');
    var childSubUl = $('.header-wrapper nav > ul > li > ul > li > ul');

    mainLi.on('hover', function(e) {
      if ($(window).width() > 1199 && !$(this).hasClass('hover') &&
          $(this).is(':hover')) {
        $(this).addClass('hover');
        $(this).children('ul').stop(true, false).fadeIn(150);
        e.preventDefault();
      } else if ($(window).width() > 1199 && $(this).hasClass('hover')) {
        $(this).children('ul').stop(true, false).fadeOut(150);
        $(this).removeClass('hover');
        e.preventDefault();
      }
    });

    childLi.on('hover', function(e) {
      var parentUl = $(this).parent('ul');
      if ($(window).width() > 1199 && !parentUl.hasClass('sub-menu-columns')) {
        $(this).children('ul').stop(true, false).fadeToggle(150);
        e.preventDefault();
      }
    });

    childUl.on('hover', function(e) {
      var elm, off, l, w, docH, docW, isEntirelyVisible;
      if ($(window).width() > 1199) {
        $(this).addClass('hover');
        $(this).children('ul').stop(true, false).fadeIn(150);
        e.preventDefault();

        elm = $('ul:first', this);
        if (elm.length) {
          off = elm.offset();
          l = off.left;
          w = elm.width();
          docH = $(window).height();
          docW = $(window).width();

          isEntirelyVisible = (l + w <= docW);

          if (!isEntirelyVisible) {
            $(this).addClass('edge');
          } else {
            jQuery.noop();
          }
        }
      } else if ($(window).width() > 1199 && $(this).hasClass('hover')) {
        $(this).children('ul').stop(true, false).fadeOut(150);
        $(this).removeClass('hover');
        e.preventDefault();

        elm = $('ul:first', this);
        if (elm.length) {
          off = elm.offset();
          l = off.left;
          w = elm.width();
          docH = $(window).height();
          docW = $(window).width();

          isEntirelyVisible = (l + w <= docW);

          if (!isEntirelyVisible) {
            $(this).addClass('edge');
          } else {
            jQuery.noop();
          }
        }
      } else {
        jQuery.noop();
      }
    });

    childSubLi.on('hover', function(e) {
      if ($(window).width() > 1199) {
        $(this).children('ul').stop(true, false).fadeToggle(150);
        e.preventDefault();
      }
    });

    var mobileLink = $(
        '.header-mobile-menu > div > nav > ul li.sidr-class-menu-item-has-children > a');
    mobileLink.append('<i class="fa fa-angle-down" aria-hidden="true"></i>');
    var mobileIcon = $(
        '.header-mobile-menu > div > nav > ul li.sidr-class-menu-item-has-children a i');

    mobileIcon.on('click', function(e) {
      e.preventDefault();
      e.stopPropagation();
      var $menuitem = $(this).parents().eq(1);
      var $children = $menuitem.first().children('ul');
      if ($(window).width() <= 1199 && !$menuitem.hasClass('active')) {
        $menuitem.addClass('active');
        $children.slideDown(400);
      } else if ($(window).width() <= 1199 && $menuitem.hasClass('active')) {
        $menuitem.removeClass('active');
        $children.slideUp(400);
      }
    });

    // Equal height blog grid title and excerpt
    var $blogArticlesFix;
    if ($('#layout-container').hasClass('blog-list') ||
        $('#layout-container').hasClass('archive-list')) {
      $blogArticlesFix = function() {
        $.noop();
      };
    } else {
      var $blogArticles = $('.blog-articles');
      $blogArticlesFix = function() {
        $blogArticles.each(function() {
          var $art, $title, $innerMedia, $excerpt;
          var $this = $(this);
          $art = $this.find('article .post-inner');
          $title = $art.find('.post-title');
          $innerMedia = $art.find(
              '.post-thumbnail img, .post-gallery, .post-audio iframe, .post-video iframe');
          $excerpt = $art.find('.post-content');

          $art.matchHeight();
          $title.matchHeight();
          $excerpt.matchHeight();
          setTimeout(function() {
            $innerMedia.matchHeight({byRow: false}), 200;
          });
        });
      };
      $blogArticlesFix();
    }

    // Equal height for posts module inners
    var $postsModule = $('.st-posts-module');
    var $postsModuleFix = function() {
      $postsModule.each(function() {
        var $post, $title, $media;
        var $this = $(this);
        var $galleryInnerImg = $('.st-posts-module-gallery-inner img');
        $post = $this.find('.st-posts-module-single');
        $title = $this.find('.st-posts-module-single .st-posts-module-title');
        $media = $this.find(
            '.st-posts-module-thumbnail, .st-posts-module-gallery, .st-posts-module-video, .st-posts-module-audio');
        $post.matchHeight();
        $title.matchHeight();
        $galleryInnerImg.imagesLoaded(function() {
          $media.matchHeight({byRow: false});
        });
      });
    };
    $postsModuleFix();

    // Equal height for pages module title and excerpt
    var $pagedGrid = $('.st-pages-grid-module');
    var $pagesGridFix = function() {
      $pagedGrid.each(function() {
        var $title, $excerpt;
        var $this = $(this);
        $title = $this.find('.st-pages-grid-item .st-pages-grid-item-title');
        $excerpt = $this.find(
            ' .st-pages-grid-item .st-pages-grid-item-excerpt');
        $title.matchHeight(true);
        $excerpt.matchHeight(true);
      });
    };
    $pagesGridFix();

    // Equal height for related posts block on single blog post
    var $relatedPosts = $('.post-related-posts');
    $relatedPosts.each(function() {
      var $this = $(this);
      var $title = $this.find('.post-related-post .post-related-post-title');
      $title.matchHeight(true);
    });

    // Equal height for info box
    var $row = $('.row');
    $row.each(function() {
      var $this = $(this);
      var $infobox = $this.find('.col .square_box_2-icon');
      $infobox.matchHeight(true);
    });

    // Equal height for team member block
    var $teamMemberBlock = $('.st-team-member-block');
    $teamMemberBlock.each(function() {
      var $this = $(this);
      var $memberinfo = $this.find(
          '.st-team-member-block-photo, .st-team-member-block-info');
      if ($this.hasClass('ext')) {
        $memberinfo.matchHeight(true);
      }
    });

    // Equal height for team member info
    var $teamMemberInfo = $('.st-team-member-info');
    $teamMemberInfo.each(function() {
      var $this = $(this);
      var $memberinfo = $this.find(
          '.st-team-member-info-photo, .st-team-member-info-inner');
      $memberinfo.matchHeight(true);
    });

    // Equal height for advanced blockquote
    var $advancedBlockquote = $('.st-advanced-blockquote');
    $advancedBlockquote.each(function() {
      var $this = $(this);
      var $innerdiv = $this.find(
          '.st-advanced-blockquote-left-image, .st-advanced-blockquote-right-image, .st-advanced-blockquote-info');
      $innerdiv.matchHeight(true);
    });

    // Equal height for History item
    var $historyItem = $('.st-history-item');
    $historyItem.each(function() {
      var $this = $(this);
      var $inners = $this.find(
          '.st-history-item-year, .st-history-item-image, .st-history-item-inner');
      $inners.matchHeight(true);
    });

    // Equal height for ST Info Boxes
    var $infoBoxes = $('.st-info-boxes');
    $infoBoxes.each(function() {
      var $this = $(this);
      var $item = $this.find('.aio-icon-component');
      $item.matchHeight(true);
    });

    // Equal height for Contact Block
    var $contactBlock = $('.st-contact-block');
    $contactBlock.each(function() {
      var $this = $(this);
      var $eq = $this.find(
          '.st-contact-block-image, .st-contact-block-details');
      $eq.matchHeight(true);
    });

    // Equal height for Vertical Text Block
    var $col = $('.col');
    var $block = $('.st-vertical-text-block');
    $col.each(function() {
      $block.matchHeight(true);
    });
    $block.each(function() {
      var $this = $(this);
      var $inners = $this.find(
          '.st-vertical-text-block-title-wrapper, .st-vertical-text-block-image');
      $inners.matchHeight(true);
    });

    // Equal height for testimonial widget items
    var $testimonialWidget = $('.widget_st_testimonials_widget');
    $testimonialWidget.each(function() {
      var $item = $('.st-testimonial-widget-item');
      $item.imagesLoaded(function() {
        $item.matchHeight(true);
      });
    });

    // Equal height Info Block info and image
    var $infoBlock = $('.st-info-block');
    $infoBlock.each(function() {
      var $this = $(this);
      var $infoinner = $this.find('.st-info-block-image, .st-info-block-info');
      $infoinner.matchHeight(true);
    });

    // Equal height for Vertical Carousel inners
    var $verticalCarouselSlider = $('.st-vertical-carousel-slider');
    var $verticalCarouselInners = $verticalCarouselSlider.find(
        '.st-vertical-carousel-info, .st-vertical-carousel-img');
    var $verticalCarousel = function() {
      $verticalCarouselInners.matchHeight({byRow: false});
      $verticalCarouselSlider.not('.slick-initialized').slick({
        rows: 0,
        vertical: true,
        infinite: false,
        verticalSwiping: true,
        arrows: false,
        dots: true,
        slidesToShow: 1,
        slidesToScroll: 1,
        swipeToSlide: true,
        responsive: [{breakpoint: 767, settings: {slidesToShow: 1}}],
      });
    };
    $verticalCarousel();

    // Vertical Carousel
    var $vertCarousel = $('.st-vertical-carousel');
    $vertCarousel.each(function() {
      var $this = $(this);
      var $list = $this.find('ul.slick-dots');
      var $listHeight = $list.height();
      $list.css('margin-top', '-' + $listHeight / 2 + 'px');
    });

    var vertCarouselGallery = $('.st-vertical-carousel-inner-gallery');
    vertCarouselGallery.each(function() {
      var $this = $(this);
      if ($this.hasClass('rtl')) {
        $(this).slick({
          rows: 0,
          infinite: true,
          adaptiveHeight: false,
          fade: true,
          cssEase: 'linear',
          draggable: false,
          rtl: true,
        });
      } else {
        $(this).
            slick({
              rows: 0,
              infinite: true,
              adaptiveHeight: false,
              fade: true,
              cssEase: 'linear',
              draggable: false,
            });
      }
    });

    // Info Box Description Padding Fix
    var $leftTitle = $('.left-title-icon');
    var $rightTitle = $('.right-title-icon');
    var paddingFix =
        function() {
          if ($('body').hasClass('rtl')) {
            $leftTitle.each(function() {
              var $this = $(this);
              var $iconWidth = $this.find('.aio-icon').width();
              $this.find('.aio-icon-description').
                  css('padding-right', $iconWidth + 15 + 'px');
            });

            $rightTitle.each(function() {
              var $this = $(this);
              var $iconWidth = $this.find('.aio-icon').width();
              $this.find('.aio-icon-description').
                  css('padding-left', $iconWidth + 15 + 'px');
            });
          } else {
            $leftTitle.each(function() {
              var $this = $(this);
              var $iconWidth = $this.find('.aio-icon').width();
              $this.find('.aio-icon-description').
                  css('padding-left', $iconWidth + 15 + 'px');
            });

            $rightTitle.each(function() {
              var $this = $(this);
              var $iconWidth = $this.find('.aio-icon').width();
              $this.find('.aio-icon-description').
                  css('padding-right', $iconWidth + 15 + 'px');
            });
          }
        };
    paddingFix();

    // Scroll To Top Button
    var $backToTop = $('.back-to-top');
    $(window).scroll(function() {
      var $this = $(this);
      var $height = ($(window).height()) - 150;
      if ($this.scrollTop() > $height) {
        $backToTop.fadeIn();
      } else {
        $backToTop.fadeOut();
      }
    });
    $backToTop.on('click', function() {
      $('html, body').animate({scrollTop: 0}, $(window).scrollTop() / 3);
      return false;
    });

    // PrettyPhoto
    $('a[rel^=\'prettyPhoto\']').prettyPhoto({deeplinking: false});

    // Advantage Block
    var $advantageBlock = $('.st-advantage-block');
    var $inner = $advantageBlock.children();
    var $inners = $advantageBlock.find(
        '.st-advantage-block-title, .st-advantage-block-desc');
    var $advantageBlockWidth = function() {
      $advantageBlock.each(function() {
        var $width = $inners.width();
        $inners.css('width', 'auto');
        $inners.css('width', $width);
      });
    };

    var $advantageBlockFix = function() {
      var $target = $advantageBlock.find('.hover');
      if ($(window).width() < 1199) {
        $advantageBlock.each(function() {
          $inner.css('height', '');
          $inner.matchHeight();
        });
      } else {
        $advantageBlock.each(function() {
          $inner.css('height', '');
          $inner.matchHeight({target: $target});
        });
      }
    };

    $advantageBlock.each(function() {
      var $this = $(this);
      var $div = $this.find(
          '.st-advantage-block-first, .st-advantage-block-second, .st-advantage-block-third, .st-advantage-block-fourth');
      $div.hover(function() {
        $div.removeClass('hover').addClass('unactive');
        $(this).removeClass('unactive').addClass('hover');
        descFade();

        function descFade() {
          if ($div.hasClass('hover')) {
            $div.children('div').removeClass('unactive').addClass('active');
          }
        }
      });

      $('.st-advantage-block-first').on('hover', function() {
        $(this).css('z-index', '4');
        $('.st-advantage-block-second').css('z-index', '3');
        $('.st-advantage-block-third').css('z-index', '2');
      });

      $('.st-advantage-block-second').on('hover', function() {
        $(this).css('z-index', '4');
        $('.st-advantage-block-third').css('z-index', '2');
        $('.st-advantage-block-fourth').css('z-index', '1');
      });

      $('.st-advantage-block-third').on('hover', function() {
        $(this).css('z-index', '4');
        $('.st-advantage-block-first').css('z-index', '2');
        $('.st-advantage-block-second').css('z-index', '3');
        $('.st-advantage-block-fourth').css('z-index', '2');
      });

      $('.st-advantage-block-fourth').on('hover', function() {
        $(this).css('z-index', '4');
        $('.st-advantage-block-third').css('z-index', '3');
        $('.st-advantage-block-second').css('z-index', '2');
      });
    });
    $advantageBlockFix();
    $advantageBlockWidth();

    // Animation on scroll
    if (!is_touch_device()) {
      var $stAnimation = $('.st-animation');
      $stAnimation.each(function() {
        var $this = $(this);
        var $animation = $this.attr('data-animation');
        var $inner;
        var display;

        if ($this.hasClass('st-page-navigation-item')) {
          display = 'inline-block';
        } else {
          display = 'block';
        }

        if ($this.data('animated')) {
          $inner = $this.find($this.data('animated'));
          $inner.css('opacity', '0');
          $this.waypoint(function() {
            $inner.velocity(
                $animation,
                {
                  stagger: 250,
                  drag: true,
                  display: display,
                },
            );
            try {
              this.destroy();
            } catch (e) {
              $.noop();
            }
          }, {
            offset: '85%',
            triggerOnce: true,
          });
        } else {
          $this.css('opacity', '0');
          $this.waypoint(function() {
            $this.velocity(
                $animation,
                {
                  display: display,
                },
            );
            try {
              this.destroy();
            } catch (e) {
              $.noop();
            }
          }, {
            offset: '85%',
            triggerOnce: true,
          });
        }
      });
    }

    // UVC Heading subtitle margin with square element
    var $uvcHeading = $(
        '.uvc-heading.enable-elem.square, .uvc-heading.enable-elem.square_2, .uvc-heading.enable-elem.circle, .uvc-heading.enable-elem.ring');
    $uvcHeading.each(function() {
      var $this = $(this);
      var $elem = $this.find('.st-h-before');
      var $elemWidth = $elem.width();
      var $sub = $this.find('.uvc-sub-heading');
      if ($('body').hasClass('rtl')) {
        if ($this.attr('data-halign') == 'center' ||
            $this.attr('data-halign') == 'left') {
          $.noop();
        } else {
          $sub.css('margin-right', ($elemWidth + 15) + 'px');
        }
      } else {
        if ($this.attr('data-halign') == 'center' ||
            $this.attr('data-halign') == 'right') {
          $.noop();
        } else {
          $sub.css('margin-left', ($elemWidth + 15) + 'px');
        }
      }
    });

    // Simple page block
    var $simplePageBlock = $('.st-simple-page-block');
    var $info = $simplePageBlock.find('.st-simple-page-block-info');
    var $pageBlockFix = function() {
      if ($(window).width() > 720) {
        $simplePageBlock.each(function() {
          var $this = $(this);
          var $width = $this.width();
          var $infoWidth = $width - 241;
          var $info = $this.find('.st-simple-page-block-info');
          $info.css('width', $infoWidth);
        });
      }
    };
    $info.css('width', 'auto');
    $pageBlockFix();

    // Team Member Block Simple Info
    var $teamMemberBlock = $('.st-team-member-block.simple-info');
    var $info = $teamMemberBlock.find('.st-team-member-block-info');
    var $teamMemberFix = function() {
      if ($(window).width() > 990) {
        $teamMemberBlock.each(function() {
          var $this = $(this);
          var $width = $this.width();
          var $infoWidth = $width - 150;
          var $info = $this.find('.st-team-member-block-info');
          $info.css('width', $infoWidth);
        });
      }
    };
    $info.css('width', 'auto');
    $teamMemberFix();
    $(window).on('resize', function() {
      $info.css('width', 'auto');
      $teamMemberFix();
    });

    // Shop Masonry
    var $window = $(window);
    var $wrapper = $('.st-product-list');
    var isotopeInit;
    if ($('body').hasClass('rtl')) {
      isotopeInit = function() {
        $wrapper.isotope({
          isOriginLeft: false,
          layoutMode: 'fitRows',
          columnWidth: '.product',
          fitWidth: true,
        });
        $.fn.matchHeight._update();
      };
    } else {
      isotopeInit = function() {
        $wrapper.isotope({
          layoutMode: 'fitRows',
          columnWidth: '.product',
          fitWidth: true,
        });
        $.fn.matchHeight._update();
      };
    }
    $('.product').imagesLoaded(function() {
      isotopeInit();
    });

    // Packery Fix
    var $window = $(window);
    var packeryFix, calcDoubleHeight;
    var $portfolio = $('.st-portfolio-module');
    var $packery = $('.st-portfolio-module').find('.packery');
    var $item = $packery.find('article.st-portfolio-item:not(.double-height)');
    var $image = $item.find('.st-portfolio-item-image img');
    var $doubleHeight, $height, $doubleHeightImage, $imageHeight;
    packeryFix = function() {
      $packery.each(function() {
        $image.imagesLoaded();
        $doubleHeight = $(this).find('.double-height .st-portfolio-item-image');
        $doubleHeightImage = $doubleHeight.find('img');
        $height = $doubleHeight.height();
        $image.matchHeight({byRow: false});
        $imageHeight = $image.height();
        if ($portfolio.hasClass('st-normal-padding')) {
          $doubleHeight.css('height', ($imageHeight * 2) + 14 + 'px');
          $doubleHeightImage.css('height', '100%');
        } else if ($portfolio.hasClass('st-narrow-padding')) {
          $doubleHeight.css('height', ($imageHeight * 2) + 10 + 'px');
          $doubleHeightImage.css('height', '100%');
        } else {
          $.noop();
        }
      });
    };

    // Header with admin bar on mobile
    if ($(window).width() <= 600) {
      var $headerMobile = $('.header-wrapper-mobile');
      var $windowScroll = $(window).scrollTop();
      $(window).scroll(function() {
        var scrollTop = $(window).scrollTop();
        if (scrollTop >= 46) {
          $headerMobile.addClass('mobile-scroll');
        } else {
          $headerMobile.removeClass('mobile-scroll');
        }
      });
    }

    $(window).on('resize', function() {
      $blogArticlesFix();
      $postsModuleFix();
      $pagesGridFix();
      $verticalCarousel();
      setTimeout($advantageBlockFix, 50);
      setTimeout($advantageBlockWidth, 200);
      $info.css('width', 'auto');
      $pageBlockFix();
      isotopeInit();
      packeryFix();
    });
    $(window).on('load', function() {
      isotopeInit();
      packeryFix();
    });

    $(document).on('click', '.coupon-button', function() {
      var input = $(this).next('input[name="apply_coupon"]');
      input.trigger('click');
    });

    // Comment form validation
    $('#commentform').on('submit', function(e) {
      var $this = $(this);

      $this.find('input[type="text"]').each(function() {
        var input = $(this),
            val = input.val();

        if (val == '') {
          input.addClass('invalid');
          e.preventDefault();
        }

      });

      $this.find('textarea#comment').each(function() {
        var input = $(this),
            val = input.val();

        if (val == '') {
          input.addClass('invalid');
          e.preventDefault();
        }

      });

      $this.find('input[type="email"]').each(function() {
        var input = $(this),
            val = input.val(),
            test = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i,
            is_email = test.test(val);
        if (!is_email) {
          input.addClass('invalid');
          e.preventDefault();
        }
      });
    });

    $('#commentform input[type="text"]').on('input', function() {
      var input = $(this),
          val = input.val();

      if (val !== '') {
        input.removeClass('invalid');
      }
    });

    $('#commentform textarea#comment').on('input', function() {
      var input = $(this),
          val = input.val();

      if (val !== '') {
        input.removeClass('invalid');
      }
    });

    $('#commentform input[type="email"]').on('input', function() {
      var input = $(this),
          val = input.val(),
          test = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i,
          is_email = test.test(val);
      if (is_email) {
        input.removeClass('invalid');
      }
    });

    jQuery('.vc_progress_bar').each(function() {
      var $el = jQuery(this);
      $el.waypoint(function() {
        $el.find('.vc_single_bar').each(function(index) {
          var bar = jQuery(this).find('.vc_bar'),
              val = bar.data('percentage-value');
          setTimeout(function() {
            bar.css({width: val + '%'});
          }, 200 * index);
        });
      }, {offset: '85%'});
    });

  });

})(jQuery);

// Function to convert hex format to a rgb color
function rgba2hex(color_value) {
  if (!color_value) return false;
  var parts = color_value.toLowerCase().
          match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/),
      length = color_value.indexOf('rgba') ? 3 : 2; // Fix for alpha values
  delete (parts[0]);
  for (var i = 1; i <= length; i++) {
    parts[i] = parseInt(parts[i]).toString(16);
    if (parts[i].length == 1) parts[i] = '0' + parts[i];
  }
  return '#' + parts.join('').toUpperCase(); // #F7F7F7
}

// Detect touch device (https://ctrlq.org/code/19616-detect-touch-screen-javascript)
function is_touch_device() {
  'use strict';
  return (('ontouchstart' in window)
      || (navigator.MaxTouchPoints > 0)
      || (navigator.msMaxTouchPoints > 0));
}

// Sticky header
(function($) {
  'use strict';
  var headerWrapper = $('.header-wrapper');

  $(window).scroll(function() {
    var scrollTop = $(window).scrollTop();
    if (scrollTop >= 180 && headerWrapper.hasClass('sticky')) {
      headerWrapper.addClass('on-scroll');
    } else {
      headerWrapper.removeClass('on-scroll');
    }
  });

  $(window).load(function() {
    var scrollTop = $(window).scrollTop();
    if (scrollTop >= 180) {
      headerWrapper.addClass('on-scroll');
    }
  });
  
})(jQuery);

// Sticky header for mobile
(function($) {
  'use strict';

  var headerWrapperMobile = $('.header-wrapper-mobile');

  $(window).scroll(function() {
    var scrollTop = $(window).scrollTop();
    if (scrollTop >= 100) {
      headerWrapperMobile.addClass('on-scroll');
    } else {
      headerWrapperMobile.removeClass('on-scroll');
    }
  });

  $(window).load(function() {
    var scrollTop = $(window).scrollTop();
    if (scrollTop >= 100) {
      headerWrapperMobile.addClass('on-scroll');
    }
  });

})(jQuery);

// Search Header on click
(function($) {
  'use strict';
  if ($(window).width() > 1199) {

    var $searchicon = $('.st-header-icons .st-search-icon .fa-search');
    var $searchform = $('.st-header-search');
    $searchicon.on('click touch', function() {
      if ($searchform.hasClass('click')) {
        $searchform.removeClass('click').fadeOut(300);
      } else {
        $searchform.addClass('click');
        $searchform.fadeIn(300, function() {
          $(this).find('input').focus();
        });
      }
    });
    $(document).on('click touch', function(event) {
      if (!$(event.target).
          parents().
          addBack().
          is('.st-header-search, .st-header-icons .st-search-icon .fa-search')) {
        $searchform.removeClass('click').fadeOut(300);
      }
    });
  }
})(jQuery);

// Search Header mobile on click
(function($) {
  'use strict';
  if ($(window).width() < 1199) {
    var $searchicon = $('.search-icon-mobile .fa-search');
    var $searchform = $('.st-header-search-mobile');

    $searchicon.on('click touch', function() {
      if ($searchform.hasClass('click')) {
        $searchform.removeClass('click').fadeOut(300);
      } else {
        $searchform.addClass('click');
        $searchform.fadeIn(300, function() {
          $(this).find('input').focus();
        });
      }
    });

    $(document).on('click touch', function(event) {
      if (!$(event.target).
          parents().
          addBack().
          is('.st-header-search-mobile, .search-icon-mobile .fa-search')) {
        $searchform.removeClass('click').fadeOut(300);
      }
    });

  }
})(jQuery);

// Cart Header on click
(function($) {
  'use strict';

  var $carticon = $('.st-cart-icon');
  $carticon.on('click touch', function() {
    var $cart = $carticon.find('.widget_shopping_cart_content');
    if ($cart.hasClass('click')) {
      $cart.removeClass('click').fadeOut(300);
    } else {
      $cart.addClass('click').fadeIn(300);
    }
  });

  $(document).on('click touch', function(event) {
    var $cart = $carticon.find('.widget_shopping_cart_content');
    if (!$(event.target).parents().addBack().is($carticon, $cart)) {
      $cart.removeClass('click').fadeOut(300);
    }
  });
})(jQuery);

// Page title parallax and zoom effect
(function($) {
  'use strict';
  if ($(window).width() > 1199) {
    $(window).on('scroll', function() {
      var $background = $('.title-container-background');
      var $overlay = $('.title-container-overlay');
      var $breadcrumbs = $('.title-container .breadcrumbs');
      var $title = $('.title-container-inner .page-title');
      var $subtitle = $('.title-container-inner .page-subtitle');
      var scrollTop = $(window).scrollTop();
      var onScrollCoeff = 0.0012;

      if ($(window).width() < 767) {
        $background.css({
          'background-size': 'cover',
          'background-position-y': 50 + ((scrollTop) * 0.07) + '%',
        });
      } else {
        $background.css({
          'background-size': 100 + ((scrollTop) / 20) + '%',
          'background-position-y': 50 + ((scrollTop) * 0.07) + '%',
        });
      }

      if ($overlay.parent().hasClass('enlarged')) {
        onScrollCoeff = 0.0009;
      }

      var opacity = 0.75 + ((scrollTop) * onScrollCoeff);
      if (opacity >= 1) {
        opacity = 1;
      }
      $overlay.css({
        'opacity': opacity,
      });

      opacity = 1 - ((scrollTop) * 0.01);
      if (opacity <= 0) {
        opacity = 0;
      }
      $breadcrumbs.css({
        'opacity': opacity,
      });
      $subtitle.css({
        'opacity': opacity,
      });
      $title.css({
        'top': ((scrollTop) * 0.6) + 'px',
        'opacity': opacity,
      });
    });
  }
})(jQuery);

// Product Info Styles
(function($) {
  'use strict';
  var $productInfo = $('.st-product-info');
  $productInfo.each(function() {
    var $this = $(this);
    var $color = $this.find('.st-product-info-title-sep').
        css('background-color');
    var $newcolor = rgba2hex($color);
    var $style = '<style>\n';
    $style += '\n.st-product-info-desc ul li:before{background-color:' +
        $newcolor + ' !important}';
    $style += '\n</style>';
    $('head').append($style);
  });
})(jQuery);

// Ultimate Tabs Ul Height
(function($) {
  'use strict';
  var $ultTabs = $('.ult_tabs');
  $ultTabs.each(function() {
    var $this = $(this);
    var $listItemHeight = parseInt(
        $this.find('ul.ult_tabmenu.adamas_style_2 li').css('height'));
    $this.find('ul.ult_tabmenu.adamas_style_2').height($listItemHeight);
  });
})(jQuery);

// Gallery Post
(function($) {
  'use strict';

  var time = 7;
  var $bar, $slick, isPause, tick, percentTime;

  $slick = $('.post-gallery, .st-posts-module-gallery-inner');

  if ($('body').hasClass('rtl')) {
    $slick.slick({
      rows: 0,
      slidesToShow: 1,
      slidesToScroll: 1,
      rtl: true,
    });
  } else {
    $slick.slick({
      rows: 0,
      slidesToShow: 1,
      slidesToScroll: 1,
    });
  }

  $bar = $('.post-gallery-progress .progress');

  $('.post-gallery, .st-posts-module-gallery-inner').on({
    mouseenter: function() {
      isPause = true;
    },
    mouseleave: function() {
      isPause = false;
    },
  });

  function startProgressbar() {
    resetProgressbar();
    percentTime = 0;
    isPause = false;
    tick = setInterval(interval, 10);
  }

  function interval() {
    if (isPause === false) {
      percentTime += 1 / (time + 0.1);
      $bar.css({width: percentTime + '%'});
      if (percentTime >= 100) {
        $slick.slick('slickNext');
        startProgressbar();
      }
    }
  }

  function resetProgressbar() {
    $bar.css({width: 0 + '%'});
    clearTimeout(tick);
  }

  startProgressbar();

})(jQuery);

// Posts sharing
(function($) {
  'use strict';
  $('.post-sharing-inner').each(function() {
    var $this = $(this),
        $link = $this.data('link'),
        $shares = $this.data('shares');
    $(this).jsSocials({
      shares: $shares,
      showLabel: false,
      showCount: false,
      url: '' + $link + '',
    });
  });
})(jQuery);

// Single product sharing
(function($) {
  'use strict';
  var $this = $('.st-single-product-sharing-inner'),
      $shares = $this.data('shares');
  $this.jsSocials({
    shares: $shares,
    showLabel: false,
    showCount: false,
  });
})(jQuery);

// Generating select
(function($) {
  'use strict';
  if ($('body').hasClass('rtl')) {
    $('.lang-select select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-lang-switch',
      dir: 'rtl',
    }).on('change', function() {
      var url = $(this).val();
      if (url) {
        window.location = url;
      }
      return false;
    });
    $('.topbar-switcher:not(.no-select2) select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-topbar-addresses-switch',
      dir: 'rtl',
    }).on('change', function() {
      $('ul.topbar-info').each(function() {
        var $this = $(this);
        var $rendered = $('.topbar-switcher select').val();
        if ($rendered.length && $this.is('#' + $rendered)) {
          $this.show();
        } else {
          $this.hide();
        }
      });
    });
    $('.topbar-switcher:not(.no-select2) select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-topbar-addresses-switch',
      dir: 'rtl',
    }).on('select2:select', function() {
      $('ul.topbar-info').each(function() {
        var $this = $(this);
        var $rendered = $('.topbar-switcher select').val();
        if ($rendered.length && $this.is('#' + $rendered)) {
          $this.show();
        } else {
          $this.hide();
        }
      });
    });
    $('.widget_archive select, .widget_categories select').select2({
      width: '85%',
      minimumResultsForSearch: '-1',
      dir: 'rtl',
    });
    $('.wpcf7-form-control-wrap select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-wpcf7-form-control-wrap',
      dir: 'rtl',
    });
    $('.woocommerce-ordering select').select2({
      width: '200px',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-woocommerce-ordering',
      dir: 'rtl',
    });
    $('.widget_layered_nav select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-layered-nav',
      dir: 'rtl',
    });
    $('.widget_product_categories select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-product-categories',
      dir: 'rtl',
    });
    $('.variations .value select').select2({
      width: '80%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-single-product-variations',
      dir: 'rtl',
    }).on('select2:select', function() {
      $('.variations .value select').select2({
        width: '80%',
        minimumResultsForSearch: '-1',
        dropdownCssClass: 'st-single-product-variations',
        dir: 'rtl',
      });
    });

    $(document).on('mouseover', '#yith-quick-view-modal', function() {
      if ($(this).find('.select2').length) {
        $.noop();
      } else {
        $('.variations .value select').select2({
          width: '80%',
          minimumResultsForSearch: '-1',
          dropdownCssClass: 'st-qw-product-variations',
          dir: 'rtl',
        }).on('select2:select', function() {
          $('.variations .value select').select2({
            width: '80%',
            minimumResultsForSearch: '-1',
            dropdownCssClass: 'st-qw-product-variations',
            dir: 'rtl',
          });
        });
      }
    });
  } else {
    $('.lang-select select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-lang-switch',
    }).on('change', function() {
      var url = $(this).val();
      if (url) {
        window.location = url;
      }
      return false;
    });
    $('.topbar-switcher:not(.no-select2) select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-topbar-addresses-switch',
    }).on('change', function() {
      $('ul.topbar-info').each(function() {
        var $this = $(this);
        var $rendered = $('.topbar-switcher select').val();
        if ($rendered.length && $this.is('#' + $rendered)) {
          $this.show();
        } else {
          $this.hide();
        }
      });
    });
    $('.topbar-switcher:not(.no-select2) select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-topbar-addresses-switch',
    }).on('select2:select', function() {
      $('ul.topbar-info').each(function() {
        var $this = $(this);
        var $rendered = $('.topbar-switcher select').val();
        if ($rendered.length && $this.is('#' + $rendered)) {
          $this.show();
        } else {
          $this.hide();
        }
      });
    });
    $('.widget_archive select, .widget_categories select').
        select2({width: '85%', minimumResultsForSearch: '-1'});
    $('.wpcf7-form-control-wrap select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-wpcf7-form-control-wrap',
    });
    $('.woocommerce-ordering select').select2({
      width: '200px',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-woocommerce-ordering',
    });
    $('.widget_layered_nav select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-layered-nav',
    });
    $('.widget_product_categories select').select2({
      width: '100%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-product-categories',
    });
    $('.variations .value select').select2({
      width: '80%',
      minimumResultsForSearch: '-1',
      dropdownCssClass: 'st-single-product-variations',
    }).on('select2:select', function() {
      $('.variations .value select').select2({
        width: '80%',
        minimumResultsForSearch: '-1',
        dropdownCssClass: 'st-single-product-variations',
      });
    });

    $(document).on('mouseover', '#yith-quick-view-modal', function() {
      if ($(this).find('.select2').length) {
        $.noop();
      } else {
        $('.variations .value select').select2({
          width: '80%',
          minimumResultsForSearch: '-1',
          dropdownCssClass: 'st-qw-product-variations',
        }).on('select2:select', function() {
          $('.variations .value select').select2({
            width: '80%',
            minimumResultsForSearch: '-1',
            dropdownCssClass: 'st-qw-product-variations',
          });
        });
      }
    });
  }

})(jQuery);

// Shop tooltips
(function($) {
  'use strict';
  var $productInner = $('.st-product-inner-wrapper');
  $productInner.each(function() {
    var $this = $(this);
    var $quickView = $this.find('.yith-wcqv-button');
    var $cart = $this.find('.add_to_cart_button');
    var $readmore = $this.find('.outofstock');
    var $grouped = $this.find('.product_type_grouped');
    var $wishAdd = $this.find('.add_to_wishlist');
    var $wishAddBrowse = $this.find(
        '.yith-wcwl-wishlistaddedbrowse>a, .yith-wcwl-wishlistexistsbrowse>a');
    var $compare = $this.find('.compare');

    $quickView.append(
        '<div class="st-shop-tooltip">' + st_localize_script.quick_view +
        '</div>');
    $cart.append(
        '<div class="st-shop-tooltip">' + st_localize_script.add_to_cart +
        '</div>');
    $readmore.append(
        '<div class="st-shop-tooltip">' + st_localize_script.read_more +
        '</div>');
    $grouped.append(
        '<div class="st-shop-tooltip">' + st_localize_script.view_products +
        '</div>');
    $wishAdd.append(
        '<div class="st-shop-tooltip">' + st_localize_script.add_to_wishlist +
        '</div>');
    $wishAddBrowse.append(
        '<div class="st-shop-tooltip">' + st_localize_script.wishlist +
        '</div>');
    $compare.append(
        '<div class="st-shop-tooltip">' + st_localize_script.compare +
        '</div>');
  });
})(jQuery);

// Shop tooltip for ".added_to_cart" and ".compare .added"
(function($) {
  'use strict';
  $(document).
      on('mouseover', '.st-product-inner-wrapper .added_to_cart', function() {
        var $this = $(this);
        if ($this.hasClass('added-tooltip')) {
          $.noop();
        } else {
          $this.append(
              '<div class="st-shop-tooltip">' + st_localize_script.view_cart +
              '</div>');
          $this.addClass('added-tooltip');
        }
      });

  $(document).on('mouseover', '.st-product-inner-wrapper .compare', function() {
    var $this = $(this);
    if ($this.hasClass('added-tooltip')) {
      $.noop();
    } else {
      $this.append(
          '<div class="st-shop-tooltip">' + st_localize_script.compare +
          '</div>');
      $this.addClass('added-tooltip');
    }
  });
})(jQuery);

// Quantity input
(function($) {
  'use strict';
  $(document).on('click', '.quantity .st-quantity-increase', function() {
    var $this = $(this);
    var input = $this.parent().find('input');
    var value = input.val();
    value++;
    $('.update-cart').prop('disabled', false);
    input.val(value);
    return false;
  });
  $(document).on('click', '.quantity .st-quantity-decrease', function() {
    var $this = $(this);
    var input = $this.parent().find('input');
    var value = input.val();
    if (value > '1') {
      value--;
      $('.update-cart').prop('disabled', false);
    }
    input.val(value);
    return false;
  });
})(jQuery);

// Widget product child categories show on click
(function($) {
  'use strict';
  var $productCatsLi = $('.widget_product_categories ul li.cat-parent');
  $productCatsLi.each(function() {
    var $this = $(this);
    var $icon = '<i class="fa fa-angle-down" aria-hidden="true"></i>';
    $this.append($icon);
  });
  $(document).
      on('click', '.widget_product_categories ul li.cat-parent i', function(e) {
        e.preventDefault();
        e.stopPropagation();
        var $this = $(this);
        var $children = $this.parent().find('ul.children');
        $this.toggleClass('active');
        $children.slideToggle('slow');
      });
})(jQuery);

// Widget custom menu child ul-s show on click
(function($) {
  'use strict';
  var $navMenuLi = $('.widget_nav_menu ul li.menu-item-has-children');
  $navMenuLi.each(function() {
    var $this = $(this);
    var $icon = '<i class="fa fa-angle-down" aria-hidden="true"></i>';
    $this.append($icon);
  });
  $(document).
      on('click', '.widget_nav_menu ul li.menu-item-has-children i',
          function(e) {
            e.preventDefault();
            e.stopPropagation();
            var $this = $(this);
            var $menuitem = $this.parent();
            var $children = $menuitem.first().children('ul.sub-menu');
            if (!$menuitem.hasClass('active')) {
              $menuitem.addClass('active');
              $children.slideDown(400);
            } else {
              $menuitem.removeClass('active');
              $children.slideUp(400);
            }
          });
})(jQuery);

// Widget post child categories show on click
(function($) {
  'use strict';
  $('li.cat-item:has(ul.children)').addClass('cat-parent');
  var $catsLiParent = $('.widget_categories ul li.cat-parent');
  $catsLiParent.each(function() {
    var $this = $(this);
    var $icon = '<i class="fa fa-angle-down" aria-hidden="true"></i>';
    $this.append($icon);
  });
  $(document).on('click', '.widget_categories ul li.cat-parent i', function(e) {
    e.preventDefault();
    e.stopPropagation();
    var $this = $(this);
    var $menuitem = $this.parent();
    var $children = $menuitem.first().children('ul.children');
    if (!$menuitem.hasClass('active')) {
      $menuitem.addClass('active');
      $children.slideDown(400);
    } else {
      $menuitem.removeClass('active');
      $children.slideUp(400);
    }
  });
})(jQuery);

// Widget pages child-ul show on click
(function($) {
  'use strict';
  var $pagesLiParent = $('.widget_pages ul li.page_item_has_children');
  $pagesLiParent.each(function() {
    var $this = $(this);
    var $icon = '<i class="fa fa-angle-down" aria-hidden="true"></i>';
    $this.append($icon);
  });
  $(document).
      on('click', '.widget_pages ul li.page_item_has_children i', function(e) {
        e.preventDefault();
        e.stopPropagation();
        var $this = $(this);
        var $menuitem = $this.parent();
        var $children = $menuitem.first().children('ul.children');
        if (!$menuitem.hasClass('active')) {
          $menuitem.addClass('active');
          $children.slideDown(400);
        } else {
          $menuitem.removeClass('active');
          $children.slideUp(400);
        }
      });
})(jQuery);

// CF7 submit
(function($) {
  'use strict';
  var $formSubmit = $('.st-contact-form-submit');
  $formSubmit.on('click', function() {
    var $this = $(this);
    var $form = $this.parents('form:first');
    $form.submit();
  });
})(jQuery);

(function($) {
  'use strict';
  var wrapper = jQuery('#footer>.row');
  var isotopeInit = function() {
    if ($('body').hasClass('rtl')) {
      wrapper.isotope({
        isOriginLeft: false,
        layoutMode: 'fitRows',
        columnWidth: '.col',
        percentPosition: true,
        fitWidth: true,
      });
    } else {
      wrapper.isotope({
        layoutMode: 'fitRows',
        columnWidth: '.col',
        percentPosition: true,
        fitWidth: true,
      });
    }
  };

  $('#footer>.row .widget').imagesLoaded(function() {
    isotopeInit();
    var window = $(window);
    window.on('load', isotopeInit);
    window.on('resize', isotopeInit);
  });
})(jQuery);