(function ($) {
    "use strict";
    $(document).ready(function () {
        var pageNum = parseInt(st_ajax_data.startPage) + 1;
        var max = parseInt(st_ajax_data.maxPages);
        var nextLink = st_ajax_data.nextLink;
        var container = st_ajax_data.container;
        var $container = $(container);
        var $loadmoreanimation = $('.st-load-more-animation');
        var ready = true;

        function removeLoad() {
            $loadmoreanimation.removeClass('active');
        }

        $(window).bind('scroll', function (e) {
            e.preventDefault();
            var divTopOffset = $('.st-portfolio-items').offset().top,
                divHeight = $('.st-portfolio-items').outerHeight(),
                windowHeight = $(window).height(),
                scrollTop = $(this).scrollTop();
            if (ready && pageNum <= max && scrollTop > (divTopOffset + divHeight - windowHeight)) {
                ready = false;
                $loadmoreanimation.addClass('active');
                $.ajax({
                    type: 'GET',
                    url: nextLink,
                    dataType: 'html',
                    complete: function (XMLHttpRequest) {
                        pageNum++;
                        if (nextLink.indexOf('paged') != -1) {
                            nextLink = nextLink.replace(/\paged\=[0-9]?/, 'paged=' + pageNum);
                        } else {
                            nextLink = nextLink.replace(/\/page\/[0-9]?/, '/page/' + pageNum);
                        }
                        if ($(XMLHttpRequest.responseText).find(container).length > 0) {
                            $(XMLHttpRequest.responseText).find(container).children().each(function () {
                                var $newItems = $(this);
                                $newItems.imagesLoaded(function () {
                                    $container.isotope('insert', $newItems);
                                    $.fn.matchHeight._maintainScroll = true;
                                    removeLoad();
                                });
                            });
                        }
                    }
                }).always(function () {
                    ready = true;
                });
            }
        });
    });
})(jQuery);