/*
 * Posts Module Masonry
 */
(function ($) {
    "use strict";
    $.fn.StPostsModule = (function (posts_module_layout) {

        if (!posts_module_layout || posts_module_layout === '')
            posts_module_layout = 'fitRows';

        var $window = $(window);
        var $posts = $('.st-posts-module');
        var isotopeInit;

        if ($('body').hasClass('rtl')) {
            isotopeInit = function () {
                $posts.isotope({
                    isOriginLeft: false,
                    layoutMode: posts_module_layout,
                    masonry: {},
                    itemSelector: '.st-posts-module-single',
                    resizable: true
                });
                jQuery.fn.matchHeight._update();
            };
        } else {
            isotopeInit = function () {
                $posts.isotope({
                    layoutMode: posts_module_layout,
                    masonry: {},
                    itemSelector: '.st-posts-module-single',
                    resizable: true
                });
                jQuery.fn.matchHeight._update();
            };
        }

        isotopeInit();
        $window.on('load', isotopeInit);
        $window.on('resize', isotopeInit);

    });
})(jQuery);