<?php
/**
 * The Template for displaying product archives, including the main shop page which is a post type archive
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/archive-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.4.0
 */

global $st_adamas;
$shop_sidebar = isset( $st_adamas['shop_sidebar'] ) ? $st_adamas['shop_sidebar'] : '';

get_header( 'shop' );

?>

<?php
/**
 * woocommerce_before_main_content hook.
 *
 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
 * @hooked woocommerce_breadcrumb - 20
 */
do_action( 'woocommerce_before_main_content' );
?>

    <div class="row">
<?php if ( $shop_sidebar == 'left' || $shop_sidebar == 'both' ) { ?>
    <aside class="st-3 col sidebar-left">
		<?php
		if ( is_active_sidebar( 'woo-sidebar-left' ) ) {
			dynamic_sidebar( 'woo-sidebar-left' );
		}
		?>
    </aside><!--st-3 col sidebar-left-->
<?php } ?>
<?php
global $st_adamas;
$column_amount = isset( $st_adamas['shop_column_amount'] ) ? $st_adamas['shop_column_amount'] : 3;
$column        = '';
if ( $column_amount == 2 ) {
	$column = 'two-column';
} elseif ( $column_amount == 4 ) {
	$column = 'four-column';
} else {
	$column = 'three-column';
}
?>
<?php if ( $shop_sidebar == 'none' ){ ?>
    <div class="st-12 st-desktop-12 col <?php echo esc_attr( $column ); ?>">
	<?php } elseif ( $shop_sidebar == 'both' ) { ?>
    <div class="st-12 st-desktop-6 col <?php echo esc_attr( $column ); ?> sidebar <?php echo esc_attr( $shop_sidebar ); ?>">
	<?php } else { ?>
    <div class="st-12 st-desktop-9 col <?php echo esc_attr( $column ); ?> sidebar <?php echo esc_attr( $shop_sidebar ); ?>">
<?php } ?>
<?php if ( woocommerce_product_loop() ) : ?>

	<?php
	/**
	 * woocommerce_before_shop_loop hook.
	 *
	 * @hooked woocommerce_result_count - 20
	 * @hooked woocommerce_catalog_ordering - 30
	 */
	do_action( 'woocommerce_before_shop_loop' );
	?>

	<?php woocommerce_product_loop_start(); ?>

	<?php
	if ( wc_get_loop_prop( 'total' ) ) {
		while ( have_posts() ) : the_post(); ?>

			<?php wc_get_template_part( 'content', 'product' ); ?>

		<?php endwhile;
	}// end of the loop. ?>

	<?php woocommerce_product_loop_end(); ?>

	<?php
	/**
	 * woocommerce_after_shop_loop hook.
	 *
	 * @hooked woocommerce_pagination - 10
	 */
	do_action( 'woocommerce_after_shop_loop' );
	?>

<?php else : ?>

	<?php wc_get_template( 'loop/no-products-found.php' ); ?>

<?php endif; ?>
    </div><!--st-9 col sidebar-->
<?php if ( $shop_sidebar == 'right' || $shop_sidebar == 'both' ) { ?>
    <aside class="st-3 col sidebar-right">
		<?php
		if ( is_active_sidebar( 'woo-sidebar-right' ) ) {
			dynamic_sidebar( 'woo-sidebar-right' );
		}
		?>
    </aside><!--st-3 col sidebar-right-->
<?php } ?>
    </div><!--row-->
<?php
/**
 * woocommerce_after_main_content hook.
 *
 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
 */
do_action( 'woocommerce_after_main_content' );
?>

<?php get_footer( 'shop' ); ?>