<?php
/**
 * The Template for displaying all single products
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see        https://docs.woocommerce.com/document/template-structure/
 * @author        WooThemes
 * @package    WooCommerce/Templates
 * @version     1.6.4
 */

global $st_adamas;

get_header( 'shop' );

$single_product_width   = isset( $st_adamas['single_product_width'] ) ? $st_adamas['single_product_width'] : 'standard';
$single_product_sidebar = isset( $st_adamas['single_product_sidebar'] ) ? $st_adamas['single_product_sidebar'] : 'right';

?>

<main id="layout-container" class="shop <?php echo esc_attr( $single_product_width ); ?>">
    <div class="row">

		<?php st_adamas_breadcrumbs(); ?>

		<?php if ( $single_product_sidebar == 'left' || $single_product_sidebar == 'both' ) { ?>
            <aside class="st-3 col sidebar-left">
				<?php
				if ( is_active_sidebar( 'woo-sidebar-left' ) ) {
					dynamic_sidebar( 'woo-sidebar-left' );
				} else {
					get_sidebar( 'shop' );
				}
				?>
            </aside>
		<?php } ?>
		<?php if ( $single_product_sidebar == 'left' || $single_product_sidebar == 'right' ){ ?>
        <div class="st-12 st-desktop-9 col sidebar">
			<?php } elseif ( $single_product_sidebar == 'both' ) { ?>
            <div class="st-12 st-desktop-6 col sidebar">
				<?php } else { ?>
                <div class="st-12 col">
					<?php } ?>
					<?php while ( have_posts() ) : the_post(); ?>

						<?php wc_get_template_part( 'content', 'single-product' ); ?>

					<?php endwhile; // end of the loop. ?>
                </div><!--st-9 col sidebar-->
				<?php if ( $single_product_sidebar == 'right' || $single_product_sidebar == 'both' ) { ?>
                    <aside class="st-3 col sidebar-right">
						<?php
						if ( is_active_sidebar( 'woo-sidebar-right' ) ) {
							dynamic_sidebar( 'woo-sidebar-right' );
						} else {
							get_sidebar( 'shop' );
						}
						?>
                    </aside>
				<?php } ?>
            </div>
			<?php
			/**
			 * woocommerce_after_main_content hook.
			 *
			 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
			 */
			do_action( 'woocommerce_after_main_content' );
			?>
			<?php get_footer( 'shop' ); ?>
